/*

MACRO paNoel for kinetic analisis and representation 

This macro was develop by 
Dr. HECTOR ALEJANDRO GUIDOBALDI
Instituto de Investigaciones Biologicas y Tecnologicas (Universidad Nacional de Cordoba, Consejo Nacional de Investigaciones Cientificas y Tecnicas)
IIBYT (UNC, CONICET)
Av. Velez Sarsfield 1611, Cordoba, Argentina
Contact: <guidobaldi@gmail.com>

*************************************************************************************************************************************************************
Disclaimer

This SOFTWARE PRODUCT is provided by THE PROVIDER "as is" and "with all faults." THE PROVIDER makes no representations or warranties of any kind concerning the safety, 
suitability, lack of viruses, inaccuracies, typographical errors, or other harmful components of this SOFTWARE PRODUCT. There are inherent dangers in the use of any software, 
and you are solely responsible for determining whether this SOFTWARE PRODUCT is compatible with your equipment and other software installed on your equipment. 
You are also solely responsible for the protection of your equipment and backup of your data, and THE PROVIDER will not be liable for any damages you may suffer in connection with using, 
modifying, or distributing this SOFTWARE PRODUCT.

*************************************************************************************************************************************************************

This software is distributed under a Commons Creactive license: Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

You are free to:
	Share — copy and redistribute the material in any medium or format
	Adapt — remix, transform, and build upon the material for any purpose, even commercially.

This license is acceptable for Free Cultural Works.

The licensor cannot revoke these freedoms as long as you follow the license terms. Under the following terms:
Attribution — You must give appropriate credit, provide a link to the license, and indicate if changes were made. 
			You may do so in any reasonable manner, but not in any way that suggests the licensor endorses you or your use.
ShareAlike — If you remix, transform, or build upon the material, you must distribute your contributions under the same license as the original.
No additional restrictions — You may not apply legal terms or technological measures that legally restrict others from doing anything the license permits. 

Notices:
You do not have to comply with the license for elements of the material in the public domain or where your use is permitted by an applicable exception or limitation.
No warranties are given. The license may not give you all of the permissions necessary for your intended use. For example, other rights such as publicity, privacy, or moral rights may limit how you use the material.

https://creativecommons.org/licenses/by-sa/4.0/legalcode

*************************************************************************************************************************************************************

version 1.0.0
Permite graficar: 
	lineas de orientacion; indica si el zoide se esta moviendo hacia hard, hacia easy o hacia los costados
	dots (posicion x, y); basicamente reconstruye la ubicacion de la cabeza
		las siguientes variables las calcula sobre la base de un RUN: seteo inicial 10 cuadros en un segundo;		
	Delta VCL; mide una suerte de aceleracion, permite establecer el delta de VCL , por default et en 10%
	VCL, representa la velocidad curvilineal con colores relativos a min y max de la track y con colores absolutos
	VSL, representa la velocidad lineal con colores relativos a min y max de la track y con colores absolutos
	VAP y VAPi, representa la velocidad promedio con on colores relativos a min y max de la track y con colores absolutos
	Linearidad; representa la linearidad (VSL/VCL) con colores relativos a min y max de la track
	DF, representa la dimension Fractal para evaluar tipo de movimiento lineal, transicional o hiperactivado, con valores continuos o discretos. Se pueden graficar independientemente en la forma discrta. 
	Intensity. representa la intensidad a lo largo de la trayectoria, necesita una comlumna con los valores de intensidad
Version funcional (chequeados los calculos de las variables AG 16/10/2016) 
Version funcional (chequeado la correcta asignacion de valores a las coordenadas AG 20/09/2017)
Version registrada (AG 29/05/2018)

*/

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SECCION ASIGNACION DE VARIABLES GLOBALES

var TimeString = "";
var firstrun = true;


// titulos planilla de resultados
var titulo_result_coord_x = "x";
var titulo_result_coord_y = "y";
var titulo_result_intensity = "Intensity";
var saved_titulo_result_coord_x = "";
var saved_titulo_result_coord_y = "";
var saved_titulo_result_intensity = "";
var columns_label_length = 0;
var col_coord_label = false;
var	label_trayectoria = "Trajectory"; // esto lo dejo como relicto por si encuentro otro modo de automaticamente determinar la veriosn del MtrackJ
var saved_label_trayectoria = "";
var col_track_label = false;
var asignar_titulo_columnas_chk = false;
var col_intensidad_label = false;

var lbl_track_actual = "";

// variables de video
var v_freq = 27; 
var usar_escala_chk = true;
var escala_microscopio = 1.8229; // escala del microscopio (um/px) objetivo 10x @ 640x480

// variables de VAP globales
var	rango_vap = 10; // lo coloque en 2 para probar la VAP instantanea // rango para estimar(promediar) las VAP

// variables de longitud minima de la trayectoria para analizar
var frame_fixed_track_zoide_chk = true;
var num_frame_fixed_track_zoide = 100;
var min_trayectory_length = 0; 
var max_trayectory_length = 0; 
var min_desplazamiento_track = 0;

var long_track_len_ok = false;
var min_desplazamiento_track_ok = false;

// variables de analisis de Velocidad
var v_run = 1; // run o recorrido seteado en 1 segundo
var v_dif_vcl = 0.1; // asigna una diferencia de 10% entre las vcl 

var relative_value_chk = true;

var var_max_abs = 100;
var var_min_abs = 0;

var save_var_max_abs_vel = 100;
var save_var_min_abs_vel = 0;

var save_var_max_abs_lin = 1;
var save_var_min_abs_lin = 0;

var	save_var_max_abs_df = 2;
var save_var_min_abs_df = 1;

var red = 0;
var green = 0;
var blue = 0;

var vcl_promedio_track = "";
var vsl_promedio_track = "";
var vap_promedio_track = "";

var a_vap_z_prom_empty == true;


// variables de analisis de Intensidad
var relative_value_int_chk = true;

var	var_min_abs_int = 0;
var var_max_abs_int = 256; 

var save_var_min_int = 0;
var save_var_max_int = 256;


// variables tipo de movimiento, dimension fractal
var	DF_lineal_chk = true;
var	DF_transicional_chk = true;
var	DF_hiperactivado_chk = true;

var DF_promedio_track = 0;

// variables de tipo de graficos a dibujar

var result_image_fixed_size_chk = true;
var	ancho_imagen_result = 1280;
var	alto_imagen_result = 1024;
var save_size_image = "1280x1024";

var change_optimizar_rend_chk = false;
var concatenar_chk = true;
var	type_graph = "Orientation";
var	save_type_graph = "Orientation";

var draw_color_bar = true;
var ejec_seg_plano = true;

// variables sobre el origen de la atraccion/repulsion

var option_fuente_atractante = "Bottom side";

// variables sobre el origen de la atraccion/repulsion

var option_area_analisis = "Pre-defined sectors";
var saved_option_area_analisis = "Pre-defined sectors";
var saved_sector_analisis_lbl = "Middle sector";
var analisis_por_area = true;
var dist_ini_analisis_orientacion = 0;
var dist_fin_analisis_orientacion = 300;
var zona_analisis_ok = false;
var zone_limit_inf = "";
var zone_limit_sup = "";

var total_track_orientado = 0;
var total_track_random = 0;
var	total_track_repelido = 0;
var	total_track_DF = 0;		

var prop_track_orientado = 0;
var prop_track_random = 0;
var prop_track_repelido = 0;

// var i_order = 1;
// variables relacionadas con el analisis de DF

var option_graf_DF = "Continuous"; // esto define la forma de representar el DF, por defecto los valores continuos


// variables relacionadas con la representacion de las tracks
var desfasaje_chk = false;
var desfasaje_x = 0;
var desfasaje_y = 0;
var desfasaje_x_saved = 0;
var desfasaje_y_saved = 0;

//var zuum_chk = false; // 2018-05-17 se puede eliminar
var zuum = 1; // esto multiplica por "zuum" el tamaño de las tracks para visualizarlas mejor
var save_zuum = 1;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SECCION BOTONES DE ACCION

//-----------------------------------------------------------------
macro "Unused... Tool - " {
	} // fin macro
//-----------------------------------------------------------------

//-----------------------------------------------------------------
macro "paNoel_button Action Tool - C037T0b10NT6b10oTcb10eThb10L " {

 	 requires("1.49a");
 	  
	if (concatenar_chk == true)	run("Close All Windows");	// funcion para hacer un stack 

	setBatchMode(ejec_seg_plano); // activa el modo batch para acelerar el analisis con imagenes	
	
	run("paNoel"); // llama a la macro paNoel que esta en este mismo CODIGO

	setBatchMode(false); // sale del modo batch para mostrar las imagenes
	
} // fin de la macro
//------------------------------------------------------------------


//-----------------------------------------------------------------
macro " Delete Slice Action Tool - C037T0b10DT6b10eTcb10LThb10s" {

	current_slice = getSliceNumber()-1;
	print("current_slice",current_slice);
	run("Delete Slice");
	IJ.deleteRows(current_slice, current_slice)
    }
//-----------------------------------------------------------------
   

macro 'paNoel_button Action Tool Options' {
	
	OPCIONES();
	
	}


function OPCIONES() {

	// crea los arrays de las opciones
	type_graph_array = newArray("Lines", "Orientation", "Dots", "Delta VCL", "VCL", "VAP", "VAPi", "VSL","Linearity", "Fractal Dimension", "Intensity"); // ARRAY DE graficos
	fixed_image_size_array = newArray("1280x1024", "640x480", "320x240", "Other"); // ARRAY DE tamaños predefinidos de imagen
	zuum_array = newArray(1, 2, 4, 8);
	
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration");

	// cuadro de dialogo para elegir tipo de grafico
		Dialog.addMessage("# # #  Choose analysis  # # #"); 
	Dialog.addChoice("Choose analysis:", type_graph_array, save_type_graph); //10	
	
	Dialog.addCheckbox("Make analysis by sectors", analisis_por_area); //2016-11-11 11:26 	


	// checkbox para cambiar los titulos de las columnas	
	Dialog.addCheckbox("Choose and assign columns?", asignar_titulo_columnas_chk); //2016-11-30 9:15 	

	// cuadro de dialogo valores de configuracion de video	
		Dialog.addMessage("# # #  Video configuration  # # #"); 
	Dialog.addNumber("Set video frequency (Hz):", v_freq); //1
	Dialog.addCheckbox("Adjust image scale (pixels to micro-meter)?", usar_escala_chk); //2016-11-30 15:29 		
	Dialog.addNumber("Scale (um/px):", escala_microscopio); // 2016-11-30 10:23

	// cuadro de dialogo variables de analisis
		Dialog.addMessage("# # #  Analysis configuration  # # #"); 
	Dialog.addNumber("Run (s):", v_run); //2

	Dialog.addCheckbox("Analyse a fix number of frames per track?", frame_fixed_track_zoide_chk); // 2016-12-01 8:22
	Dialog.addNumber("Set the number of fixed frames:", num_frame_fixed_track_zoide);  // 2016-12-01 8:23

		
	// cuadro de dialogo para opciones de representacion	
		Dialog.addMessage("# # #   Representation options   # # #"); 
	Dialog.addCheckbox("Represent the result image of a fixed size", result_image_fixed_size_chk); //2016-11-02-19:25
	Dialog.addChoice("Choose the result image resolution:", fixed_image_size_array, save_size_image); // 2016-11-03-14:15	
//	Dialog.addCheckbox("zoom 2x", zuum_chk); //2016-11-12 05:47 // modifcado 2018/05/17
	Dialog.addChoice("zoom: x", zuum_array, save_zuum); // 2018-05-17-9:00	
//		Dialog.addMessage("If you choose the option 'zoom > x2 ' the image resolution is set to 1280x1024"); 
	Dialog.addCheckbox("Offset x,y coordinates", desfasaje_chk); // 2016/11/08 15:24	
					
	Dialog.addCheckbox("ADVANCED. Change performance optimization options", change_optimizar_rend_chk); //2016-11-30 9:30


	Dialog.show();

	// Asignacion de valores a partir de los cuadros de dialogo 
	// (ponerlos en orden consecutivo de acuerdo a como estan arriba 

	// asignar  tipo de grafico
	type_graph = Dialog.getChoice(); //10
	
	analisis_por_area = Dialog.getCheckbox(); //2016-11-11 11:26

	asignar_titulo_columnas_chk = Dialog.getCheckbox(); //2016-11-30 9:15 

	// asiganr valores de configuracion de video	
	v_freq = Dialog.getNumber(); //1
	usar_escala_chk = Dialog.getCheckbox(); //2016-11-30 15:29 		
	escala_microscopio = Dialog.getNumber(); // 2016-11-30 10:23
	
	// asiganr variables de analisis
	v_run = Dialog.getNumber(); //2

	frame_fixed_track_zoide_chk = Dialog.getCheckbox(); // 2016-12-01 8:22
	num_frame_fixed_track_zoide = Dialog.getNumber();  // 2016-12-01 8:23
	

	// asiganr opciones de representacion
	result_image_fixed_size_chk = Dialog.getCheckbox(); //2016-11-02-19:25
	image_size_d = Dialog.getChoice(); // 2016-11-03-14:15		
	zuum = Dialog.getChoice(); //2016-11-12 05:47
	desfasaje_chk = Dialog.getCheckbox(); // 2016/11/08 15:24		

	change_optimizar_rend_chk = Dialog.getCheckbox(); //2016-11-30 9:30

	// ALMACENAR VARIABLES saved_
	save_size_image= image_size_d;	
	save_type_graph = type_graph;
	save_zuum = zuum;

	// OPERACIONES

		if (analisis_por_area == true) DIALOGO_DEF_BORDE_AREA_ANALISIS();

		if (asignar_titulo_columnas_chk == true) { // si la ventana de resultados esta abierta entonces analiza los titutlos de las columnas
			if (isOpen("Results") == true){
				OBTENER_COLUMNS_LABEL();
			}
			else { // si la ventana de resultados esta cerrada avisa con un mensaje y aborta la ejecución
				Dialog.create("Result window is missing");
						Dialog.addMessage("A RESULT window must be open in order to proceed."); 
				Dialog.show;

			exit();
			}
		} // fin if asignar_titulo_columnas_chk

		if (frame_fixed_track_zoide_chk == false) {
			// esto modifica los parametros de rango de trayectorias porque sino quedan activos y me generan errores
			min_trayectory_length = 0; 
			max_trayectory_length = 0; 
			min_desplazamiento_track = 0;
			DIALOGO_ASIGNAR_RANGO_FRAMES();
		}

/* modificado el 2018-05-15 si funciona bien la modificacion esto se puede sacar
	
	// asigna los valores del tamaño de la imagen
		if 	(zuum_chk == true) {
			ancho_imagen_result = 1280;
			alto_imagen_result = 1024;
			zuum = 2;
		}
		else if (zuum_chk == false && image_size_d =="1280x1024") {
			ancho_imagen_result = 1280;
			alto_imagen_result = 1024;
			zuum = 1;
		}
		else if (zuum_chk == false && image_size_d =="640x480") {
			ancho_imagen_result = 640;
			alto_imagen_result = 480;
				zuum = 1;
		}
		else if (zuum_chk == false && image_size_d =="320x240") {
			ancho_imagen_result = 320;
			alto_imagen_result = 240;
			zuum = 1;
		}
		else if (zuum_chk == false && image_size_d =="Other") {

			zuum = 1;
			
			Dialog.create("Choose dimensions");

				Dialog.addNumber("Width:", ancho_imagen_result); 
				Dialog.addNumber("Heigth:", alto_imagen_result); 
			Dialog.show();

			ancho_imagen_result = Dialog.getNumber(); 
			alto_imagen_result = Dialog.getNumber();
		}
			else  {}

	
*/	


/* cambio el concepto ahora siempre esta con zoom. el tema es cuanto 2018-05-18
		// asigna los valores del zuum 2018-05-15
		if 	(zuum_chk == true) zuum = 2;
		else zuum =1;
*/			
		// asigna los valores del tamaño de la imagen
		if (image_size_d =="1280x1024") {
			ancho_imagen_result = 1280*zuum;
			alto_imagen_result = 1024*zuum;
		}
		
		else if (image_size_d =="640x480") {
			ancho_imagen_result = 640*zuum;
			alto_imagen_result = 480*zuum;
		}
		
		else if (image_size_d =="320x240") {
			ancho_imagen_result = 320*zuum;
			alto_imagen_result = 240*zuum;
		}
		else if (image_size_d =="Other") {
		
			Dialog.create("Choose dimensions");

				Dialog.addNumber("Width:", ancho_imagen_result); 
				Dialog.addNumber("Heigth:", alto_imagen_result); 
			Dialog.show();

			//obtiene los valores del tamaño de la imagen
			ancho_imagen_result = Dialog.getNumber(); 
			alto_imagen_result = Dialog.getNumber();

			// aumenta la resolucion si el zuum esta activado
			ancho_imagen_result = ancho_imagen_result*zuum; 
			alto_imagen_result = alto_imagen_result*zuum;
		}
			else  {}

	// va a un cuadro para asignar el desfasaje
		if (desfasaje_chk==true) {
			DIALOG_DESFASAJE();
		}
		else {
			desfasaje_x = 0;
			desfasaje_y = 0;		
		}
	
	// Va a subdialogos para ajustar variables especificas de los graficos
		if (type_graph=="Lines") DIALOGO_FUENTE_ATRACTANTE();
		if (type_graph=="VCL" || type_graph=="VSL" || type_graph=="VAP" || type_graph=="VAPi") DIALOGO_VEL();
		if (type_graph=="Linearity") DIALOGO_LINEARIDAD();
		if (type_graph=="Fractal Dimension") DIALOGO_DF();
		if (type_graph=="Delta VCL") DIALOGO_DELTA_VCL();
		if (type_graph=="Orientation") DIALOGO_FUENTE_ATRACTANTE();

		if (change_optimizar_rend_chk == true) DIALOGO_CHANGE_OPTIMIZAR_REND();

		firstrun = false;
		
} // fin de la macro option
//*****************************************


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_CHANGE_OPTIMIZAR_REND() {

	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Performance optimization");

	// cuadro de dialogo para  optimizacion de rendimiento	
		Dialog.addMessage("# # #   Performance optimization   # # #"); 
	Dialog.addCheckbox("Make an Image Stack", concatenar_chk); //8
	Dialog.addCheckbox("Execute in second plane", ejec_seg_plano); //9	

	Dialog.show();

		// optimizacion de rendimiento	
	concatenar_chk = Dialog.getCheckbox(); //8
	ejec_seg_plano = Dialog.getCheckbox(); //9
	
}// fin function DIALOGO_CHANGE_OPTIMIZAR_REND
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_ASIGNAR_RANGO_FRAMES() {

	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Set track parameters for analysis");

	Dialog.addNumber("Minimum number of points per track:", min_trayectory_length); //2016-11-21 16:05
	Dialog.addNumber("Maximum number of points per track:", max_trayectory_length); //2016-11-21 16:07	
	Dialog.addNumber("Minimum displacement (px):", min_desplazamiento_track); //2016-11-21 16:35
	Dialog.addMessage("(The trajectories which do not meet the above conditions are not analysed)"); 
	
	Dialog.show();
	
	min_trayectory_length = Dialog.getNumber(); //2016-11-21 16:05
	max_trayectory_length = Dialog.getNumber(); //2016-11-21 16:07	
	min_desplazamiento_track = Dialog.getNumber(); //2016-11-21 16:35
	
}// fin function DIALOGO_ASIGNAR_RANGO_FRAMES
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////*/



//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_DEF_BORDE_AREA_ANALISIS() {

	a_items = newArray("User defined", "Pre-defined sectors");
	a_sectores_analisis_lbl = newArray("Upper sector", "Middle sector", "Lower sector");
	
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Choose analysis sector");

		Dialog.addMessage("# # #  Choose type of sector  # # #"); 
  	Dialog.addRadioButtonGroup("", a_items, 1, 2, saved_option_area_analisis); 

		Dialog.addMessage("# #   User defined sectors   # #"); 
	Dialog.addNumber("Distance from the upper image edge (px):", dist_ini_analisis_orientacion); //2016-11-11 11:22
	Dialog.addNumber("Distance from the bottom image edge (px):", dist_fin_analisis_orientacion); //2016-11-11 11:23

		Dialog.addMessage("# #   Pre-defined sectors   # #"); 
	Dialog.addRadioButtonGroup("",a_sectores_analisis_lbl, 3, 1, saved_sector_analisis_lbl)
	
	Dialog.show();
	
	option_area_analisis = Dialog.getRadioButton();
	saved_option_area_analisis = option_area_analisis;

	op_temp1 = Dialog.getNumber(); //2016-11-11 11:22
	op_temp2 = Dialog.getNumber(); //2016-11-11 11:23	
	
	sector_analisis = Dialog.getRadioButton();
	saved_sector_analisis_lbl = sector_analisis;

	if (option_area_analisis == "User defined") {
		dist_ini_analisis_orientacion = op_temp1;
		dist_fin_analisis_orientacion = op_temp2;
	}

	if (option_area_analisis == "Pre-defined sectors") {
		if (sector_analisis == "Lower sector") {
			dist_ini_analisis_orientacion = 0;
			dist_fin_analisis_orientacion = floor(alto_imagen_result / 3); 
		}
		else if (sector_analisis == "Middle sector") {
			dist_ini_analisis_orientacion = floor(alto_imagen_result / 3);
			dist_fin_analisis_orientacion = 2 * floor(alto_imagen_result / 3); 
		}
		else { // sector analisis == "Upper sector"
			dist_ini_analisis_orientacion = 2* floor(alto_imagen_result / 3);
			dist_fin_analisis_orientacion = 3 * floor(alto_imagen_result / 3);	
		}
	}
		
}// fin function DIALOG_ORIENTACION
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_FUENTE_ATRACTANTE() {

  	items_fuente_atractante = newArray("Upper side", "Bottom side", "Left side", "Rigth side");
  	
  	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration "+type_graph);

  	Dialog.addRadioButtonGroup("# # #  Choose the side of the attractant source  # # #", items_fuente_atractante, 2, 2, option_fuente_atractante);

	Dialog.show();

	option_fuente_atractante = Dialog.getRadioButton;
	
}// fin function DIALOG_ORIENTACION
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_VEL() {

	//asigna valores almacenados iniciales, esto salva el problema de cuando se cambian variables 
	var_max_abs = save_var_max_abs_vel;
	var_min_abs = save_var_min_abs_vel;
		
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para elegir tipo de grafico
	Dialog.addMessage("# # #  Options  # # #"); 
	Dialog.addCheckbox("Show colour reference bar", draw_color_bar); //4
	Dialog.addCheckbox("Represent colors between the min and max values of each track?", relative_value_chk); //11

	// cuadro de dialogo para opciones de VCL	
	Dialog.addMessage("# #  Options for absolute velocity representation # #"); 

	Dialog.addNumber("Maximum absolute velocity value (um/s):", var_max_abs); //12
	Dialog.addNumber("Minimum absolute velocity value (um/s):", var_min_abs); //13		

	Dialog.show();

	// Asignacion de valores a partir de los cuadros de dialogo:
	
	// opciones de grafico
	draw_color_bar = Dialog.getCheckbox(); //4
	relative_value_chk = Dialog.getCheckbox(); //11

	// valores de velocidad absoluta
	var_max_abs =Dialog.getNumber(); //12
	var_min_abs =Dialog.getNumber(); //13

 	// almacena el valor de las variables de velocidad
 	save_var_max_abs_vel = var_max_abs;
	save_var_min_abs_vel = var_min_abs;
	
} // fin function DIALOG_VEL
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_LINEARIDAD() {

	//asigna valores almacenados iniciales, esto salva el problema de cuando se cambian variables 
	var_max_abs = save_var_max_abs_lin;
	var_min_abs = save_var_min_abs_lin;
	
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para elegir tipo de grafico
	Dialog.addMessage("# # #  Options  # # #"); 
	Dialog.addCheckbox("Show colour reference bar", draw_color_bar); //4
	Dialog.addCheckbox("Represent colors between the min and max values of each track?", relative_value_chk); //11

	// cuadro de dialogo para opciones de VCL	
	Dialog.addMessage("# #  Options for absolute Linearity representation # #"); 

	Dialog.addNumber("Maximum absolute Linearity value:", var_max_abs); //12
	Dialog.addNumber("Minimum absolute Linearity value:", var_min_abs); //13		

	Dialog.show();

	// Asignacion de valores a partir de los cuadros de dialogo:
	// opciones de grafico
	draw_color_bar = Dialog.getCheckbox(); //4
	relative_value_chk = Dialog.getCheckbox(); //11

	// valores de velocidad absoluta
	var_max_abs = Dialog.getNumber(); //12
	var_min_abs = Dialog.getNumber(); //13
	if (var_max_abs > 1) var_max_abs = 1;
	if (var_min_abs < 0) var_min_abs = 0;

	// almacena el valor de las variables de velocidad
 	save_var_max_abs_lin = var_max_abs;
	save_var_min_abs_lin = var_min_abs;
} // fin function DIALOG_LINEARIDAD
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_INTENSITY() {

	//asigna valores almacenados iniciales, esto salva el problema de cuando se cambian variables 
	var_max_abs_int = save_var_max_int;
	var_min_abs_int = save_var_min_int;
		
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para elegir tipo de grafico
	Dialog.addMessage("# # #  Options  # # #"); 
	Dialog.addCheckbox("Show colour reference bar", draw_color_bar); //int1
	Dialog.addCheckbox("Represent colors between the min and max values of each track?", relative_value_int_chk); //int2

	// cuadro de dialogo para opciones de VCL	
	Dialog.addMessage("# #  Options for absolute velocity representation # #"); 

	Dialog.addNumber("Maximum absolut Intensity value:", var_max_abs_int); //int3
	Dialog.addNumber("Minimum absolut Intensity value:", var_min_abs_int); //int4		

	Dialog.show();

	// Asignacion de valores a partir de los cuadros de dialogo:
	
	// opciones de grafico
	draw_color_bar = Dialog.getCheckbox(); //int1
	relative_value_int_chk = Dialog.getCheckbox(); //int2

	// valores de velocidad absoluta
	var_max_abs_int =Dialog.getNumber(); //int3
	var_min_abs_int =Dialog.getNumber(); //int4

 	// almacena el valor de las variables de velocidad
 	save_var_max_abs_vel = var_max_abs_int;
	save_var_min_abs_vel = var_min_abs_int;
	
} // fin function DIALOG_INTENSITY

//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_DELTA_VCL() {

	v_dif_vcl_porcentual = v_dif_vcl*100; // convierte la proporcion en porcentaje
 	
  	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para opciones de VCL	
	Dialog.addMessage("# # #  Options  # # #"); 
	Dialog.addNumber("VCL difference (%):", v_dif_vcl_porcentual); //3

	Dialog.show();

	v_dif_vcl_porcentual = Dialog.getNumber(); //3

	v_dif_vcl = v_dif_vcl_porcentual / 100; // convierte el porcentaje en proporcion
	
}//fin function DIALOG_VCL_dif
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_DF() {

  	items = newArray("Categorical", "Continuous");
  	
  	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para elegir tipo de grafico
	Dialog.addMessage("# # #  Fractal Dimension representation options  # # #"); 

  	Dialog.addRadioButtonGroup("", items, 1, 2, option_graf_DF);

	Dialog.show();

  	if (Dialog.getRadioButton=="Continuous") {
		option_graf_DF = "Continuous";
  		DIALOGO_DF_CONTINUO();
  	}
  	else {
		option_graf_DF = "Categorical";
  		DIALOGO_DF_CATEGORICO();  		
  	}
	
}//fin function DIALOG_DF
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_DF_CATEGORICO() {

	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para elegir tipo de grafico
	Dialog.addMessage("# # #  Choose the type of movement to represent  # # #"); 
	Dialog.addCheckbox("Lineal", DF_lineal_chk); 
	Dialog.addCheckbox("Transitional", DF_transicional_chk);
	Dialog.addCheckbox("Hiperactivated", DF_hiperactivado_chk); 

	Dialog.show();

	DF_lineal_chk = Dialog.getCheckbox();
	DF_transicional_chk = Dialog.getCheckbox();
	DF_hiperactivado_chk = Dialog.getCheckbox();
	
} // fin function DIALOGO_DF_CATEGORICO
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOGO_DF_CONTINUO() {

	//asigna valores almacenados iniciales, esto salva el problema de cuando se cambian variables 
	var_max_abs = save_var_max_abs_df;
	var_min_abs = save_var_min_abs_df;
	
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration of "+type_graph);

	// cuadro de dialogo para elegir tipo de grafico
	Dialog.addMessage("# # #  Options  # # #"); 
	Dialog.addCheckbox("Show colour reference bar", draw_color_bar); //4
	Dialog.addCheckbox("Represent colors between the min and max values of each track?", relative_value_chk); //11

	// cuadro de dialogo para opciones de VCL	
	Dialog.addMessage("# #  Options for absolute Fractal Dimension representation # #"); 

	Dialog.addNumber("Maximum absolut Fractal Dimension value:", var_max_abs); //12
	Dialog.addNumber("Minimum absolut Fractal Dimension value:", var_min_abs); //13		

	Dialog.show();

	// Asignacion de valores a partir de los cuadros de dialogo:
	// opciones de grafico
	draw_color_bar = Dialog.getCheckbox(); //4
	relative_value_chk = Dialog.getCheckbox(); //11

	// valores de velocidad absoluta
	var_max_abs = Dialog.getNumber(); //12
	var_min_abs = Dialog.getNumber(); //13
	if (var_max_abs > 2) var_max_abs = 2;
	if (var_min_abs < 1) var_min_abs = 1;

	// almacena el valor de las variables de velocidad
 	save_var_max_abs_df = var_max_abs;
	save_var_min_abs_df = var_min_abs;
} // fin function DIALOG_DF_CONTINUO
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
////////////////////////////
function DIALOG_DESFASAJE() {

	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Offset trajectory configuration");


	// cuadro de dialogo para opciones de desfasaje	
	Dialog.addMessage("# # Offset coordinates x,y # #"); 

	Dialog.addNumber("Offset X coordinates (px):", desfasaje_x_saved); 
	Dialog.addNumber("Offset Y coordinates (px):", desfasaje_y_saved); 

	Dialog.show();

	desfasaje_x_saved = Dialog.getNumber();
	desfasaje_y_saved = Dialog.getNumber();

/* sacado el 2018-05-17 porque cambien la forma en que hace el zoom. Si funciona ok eliminar
	// agregado 2015-05-15 es una magnificacion completa de la imagen
	if 	(zuum_chk == true) zuum = 2;
	else zuum = 1;
*/	
	desfasaje_x = desfasaje_x_saved*zuum;
	desfasaje_y = desfasaje_y_saved*zuum;
	
	return desfasaje_x();
	return desfasaje_y();
	
} // fin function DIALOG_DESFASAJE
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// SECCION MACROS EJECUTABLES


////////////////////////////
macro "Close All Windows" { 
///////////////////////////

	if (nImages>0) {
		showMessageWithCancel("## Close open images ##","This will close ALL OPEN images!!\nContinue?");
	}

	while (nImages>0) { 
        selectImage(nImages); 
        close(); 
    } 
} // fin macro
//mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm


////////////////
macro "paNoel" {
////////////////
		
// checkeo first run
	if (firstrun==true) {
		OPCIONES();
		firstrun = false;
	}


// variables que se deben inicalizar cada vez que se ejecta la macro

	var check_name_track = NaN;
	var check_coord_x = NaN;
	var check_coord_y = NaN;
	var check_intensidad = NaN;	

	var i_order = 1;
	var desplazamiento_minimo_temp =0;

// fin variables que se deben inicalizar cada vez que se ejecta la macro
////////////////
	
	GET_TIME();
	print(TimeString+": Starting analysis ..."); // track process
	
	// esto chequea que este abierta la ventana de resultados, sino no hace nada y sla de la macro
	if (isOpen("Results")==false) {
		showMessage("RESULT window missing", "There is no RESULT window open to analyse.");
			GET_TIME();
			print(TimeString+": Analysis aborted: There was no RESULT window open."); // track process
		exit();
	} // fin del if

	// esto lo puse para hacer el seguimieto de los zoides que estoy analizando
	n_zoide = 0;
	

	// Verificaciones antes de empezar a evaluar todos los zoides

	// esto verifica que el titulo de las columnas de las tracks, coord_ x y coord_y sean correctos, sino propone asiganrlo manualmente
	check_name_track = getResult(label_trayectoria, 0);
	check_coord_x = getResult(titulo_result_coord_x, 0);
	check_coord_y = getResult(titulo_result_coord_y, 0);
	check_intensidad = getResult(titulo_result_intensity, 0);	
	
	if (isNaN(check_name_track)==true || isNaN(check_coord_x)==true || isNaN(check_coord_y)==true ) {
			OBTENER_COLUMNS_LABEL();	 
	}

	// checkea que este bien el nombre de la columna de intensidad
	if (type_graph == "Intensity") {;
				if (isNaN(check_intensidad)==true ) OBTENER_COLUMNS_LABEL();	 
	}

	// aca crea tablas de resultados
	// TABLA DE RESULTADOS DE ORIENTACION
	if (type_graph == "Orientation") {
		if (isOpen("Orientation resume") == true) {
			selectWindow("Orientation resume");
			run("Close");
			CREAR_TABLE_ORIENTACION_RESUMEN();
		}
		else {
			CREAR_TABLE_ORIENTACION_RESUMEN();	
		}
	}

	// TABLA DE RESULTADOS DE "Fractal Dimension"
	if (type_graph == "Fractal Dimension") {
		if (isOpen("Fractal Dimension resume") == true) {
			selectWindow("Fractal Dimension resume");
			run("Close");
			CREAR_TABLE_DF_RESUMEN();
		}
		else {
			CREAR_TABLE_DF_RESUMEN();	
		}
	}

	// TABLA DE RESULTADOS DE VELOCIDADES PROMEDIO POR TRAYECTORIA
	if (type_graph == "VCL" || type_graph == "VSL" || type_graph == "VAP" || type_graph=="VAPi") {
		if (isOpen("Velocities resume") == true) {
			selectWindow("Velocities resume");
			run("Close");
			CREAR_TABLE_VELOCIDADES_RESUMEN();
		}
		else {
			CREAR_TABLE_VELOCIDADES_RESUMEN();	
		}
	}
	
	// ACA EMPIEZA EL BUCLE PARA ESCANEAR LAS DISTINTAS TRACKS
	// TODO LO QUE SE PONGA DENTRO DE ESTE BUCLE SE REPITE UNA CANTIDAD DE VECES IGUAL A LA CANTIDAD DE TRACKS
	
	// este bucle indica donde empieza y termina la track
	for (z_num_orden = 1; z_num_orden < nResults; z_num_orden++) {

		// esto lo puse para hacer el seguimieto de los zoides que estoy analizando
		n_zoide++;	// print(" \nzoide n", n_zoide,"\n "); // log record
	
		// identifica el nombre la track
		name_track = getResult(label_trayectoria, z_num_orden-1); // asigna el nombre de la track buscando en la columna label determinada anterioremente
//			print(name_track); // log record

		// asigna el numero de la track para usarlo como titulo
		lbl_track_actual = name_track; 
		
		// indica en que numero de orden -1 inicia la track
		inicio_track = z_num_orden;

		// asigna las coordenadas iniciales (x,y) de la track
		coord_x_ini = getResult(titulo_result_coord_x, inicio_track-1)*zuum;	// print("coord_x_ini sin corregir", coord_x_ini); // log record
		coord_y_ini = getResult(titulo_result_coord_y, inicio_track-1)*zuum;

		// esto hace que avance en la secuencia de puntos identificar donde termina la track
		while (name_track == getResult(label_trayectoria, z_num_orden) && z_num_orden < nResults-1) {
			z_num_orden++;
		} // fin while

		// asigna el numero de posicion donde termina la track
		fin_track = z_num_orden;

		// asigna las coordenadas (x,y) finales de la track temporales para usar en el "desplazamiento mínimo"
		coord_x_fin_temp = getResult(titulo_result_coord_x, fin_track-1)*zuum;	// print("coord_x_ini sin corregir", coord_x_ini); // log record
		coord_y_fin_temp = getResult(titulo_result_coord_y, z_num_orden-1)*zuum;

		// Establece los limites de la zona de analisis, esto es para analisis por areas
	 	zone_limit_inf = alto_imagen_result - dist_fin_analisis_orientacion;
	 	zone_limit_sup = alto_imagen_result - dist_ini_analisis_orientacion;
	 	
////////	 	
	 	// ACA SE DEFINEN LAS CONDICIONES SI SE VAN A ANALIZAR O NO LAS TRAYECTORIAS
///////
		// verifica que este activado el analisis por areas	
	 	if (analisis_por_area == false) {
	 		 zona_analisis_ok = true;
	 	}
	 	if (analisis_por_area == true) {
		 	if (coord_y_ini > zone_limit_inf && coord_y_ini < zone_limit_sup) {
		 		zona_analisis_ok = true;	 		
		 	}
    		else {
    			zona_analisis_ok = false;
    		}  		
//    		print("zona_analisis_ok", zona_analisis_ok, "coord_y_ini", coord_y_ini,"zone_limit_inf", zone_limit_inf, "zone_limit_sup", zone_limit_sup); // log record
	 	}
	 	
		// verifica que la cantidad de puntos sean suficientes y no excesivos para dibujar la trayectoria
		// verifica que haya puntos suficientes si la condicion es un numero fijo de puntos 
		if (frame_fixed_track_zoide_chk == true) {
			if ((fin_track - inicio_track) >= num_frame_fixed_track_zoide + (floor(v_run*v_freq))) long_track_len_ok = true;
		}
		else { // verifica que haya puntos suficientes si la condicion es un rango de puntos 
			((fin_track - inicio_track) > min_trayectory_length && (fin_track - inicio_track) < max_trayectory_length ) long_track_len_ok = true;
		}

		// Calcula la variable de "desplazamiento minimo" la compara con el minimo admitido
		desplazamiento_minimo_temp = sqrt(pow((coord_x_fin_temp - coord_x_ini), 2) + pow((coord_y_fin_temp - coord_y_ini), 2));
		if (desplazamiento_minimo_temp > min_desplazamiento_track) min_desplazamiento_track_ok = true;
//			print("#track", name_track, "desplazamiento_minimo_temp", desplazamiento_minimo_temp, "min_desplazamiento_track_ok", min_desplazamiento_track_ok );

////////		
		// ACA VAN LAS FUCIONES que necesitemos para calcular lo que sea en cada espermatozoide:
///////
		// las variables son a transferir a las funciones son: inicio_track y fin_track
		
		// este bloque if verifica que se cumplan todas las condiciones para dibujar las tracks a saber:
		// 1. que la longitud de la trayectoria sea la correcta entre un minimo y maximo de frames establecido (long_track_len_ok)
		// 2. que el punto de inicio este en la zona de analisis (zona_analisis_ok)
		// 3. que el desplazamiento de la trayectoria sea superior a un minimo (min_desplazamiento_track_ok), esto descarta puntos inmoviles
		
		if (long_track_len_ok == true && zona_analisis_ok == true && min_desplazamiento_track_ok == true) {

			// asigna los distintos tipos de analisis
			
			// funcion para dibujar trayectoria con dots
			if (type_graph == "Dots") DIBUJAR_DOTS(inicio_track, fin_track);	
							
			// funcion para dibujar trayectoria con lineas
			if (type_graph == "Lines") DIBUJAR_LINEAS_ORIENTACION(inicio_track, fin_track); 
			
			// funcion para graficar el DELTA DE VCL
			if (type_graph == "Delta VCL") DIBUJAR_DIF_VCL(inicio_track, fin_track);	
			
			// funcion para graficar VCL
			if (type_graph == "VCL") DIBUJAR_VELOCIDADES(inicio_track, fin_track);	
			
			// funcion para graficar VSL
			if (type_graph == "VSL") DIBUJAR_VELOCIDADES(inicio_track, fin_track);	
			
			// funcion para graficar VAP
			if (type_graph == "VAP") {
				rango_vap = 10;
				DIBUJAR_VELOCIDADES(inicio_track, fin_track);
			}

			// funcion para graficar VAPi (instantanea)
			if (type_graph == "VAPi") {
				rango_vap = 2;
				DIBUJAR_VELOCIDADES(inicio_track, fin_track);				
			}
					
			// funcion para graficar Linearidad
			if (type_graph == "Linearity") DIBUJAR_LINEARIDAD(inicio_track, fin_track);	
			
			// funcion para graficar Dimension Fractal
			if (type_graph == "Fractal Dimension") DIBUJAR_DF(inicio_track, fin_track);	
					
			// funcion para graficar Dimension Fractal
			if (type_graph == "Orientation") DIBUJAR_ORIENTACION(inicio_track, fin_track);	
					
			// funcion para graficar la Intensidad
			if (type_graph == "Intensity") DIBUJAR_INTENSIDAD(inicio_track, fin_track);
			
			// Terminó de ejecutar las distintas funciones
				
			// esto muestra los dibujos de las tracks a medida que las termina
			// si se va a crear un stack, entonces no las muestra para hacerlo mas rápido
			if (concatenar_chk == false) setBatchMode(false); // esto es para que muestre las figuras a medida que las termina

		} // fin del if que verifica que la longitud sea lo suficientemente grande como para analizar los resultados
	//sigue el bucle del for para la proxima track

		// reseteo de variables
		long_track_len_ok = false; 
		zona_analisis_ok = false;
		min_desplazamiento_track_ok = false;
	
	// muestra la barra de progreso
	showProgress(-(fin_track-1)/nResults);

	} // fin del for 

	// obtiene la lista de imagenes abiertas 
  	list_images = getList("image.titles");

	// verifica que haya 2 o mas imagenes para concatenar y hacer un stack 
	if (concatenar_chk == true && list_images.length>1 ) CONCATENAR_IMAGENES();	// funcion para hacer un stack
	showProgress(-(nResults+1)/nResults);	
		GET_TIME();
		print(TimeString+": End of "+type_graph+" analysis: OK"); // track process
} // aca termina la macro paNoel
//mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// SECCION FUNCIONES
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
// funcion para obtener una estampa de tiempo
function GET_TIME() {
     MonthNames = newArray("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
     DayNames = newArray("Sun", "Mon","Tue","Wed","Thu","Fri","Sat");
     getDateAndTime(year, month, dayOfWeek, dayOfMonth, hour, minute, second, msec);
     TimeString ="Date: "+DayNames[dayOfWeek]+" ";
     if (dayOfMonth<10) {TimeString = TimeString+"0";}
     TimeString = TimeString+dayOfMonth+"-"+MonthNames[month]+"-"+year+"\nTime: ";
     if (hour<10) {TimeString = TimeString+"0";}
     TimeString = TimeString+hour+":";
     if (minute<10) {TimeString = TimeString+"0";}
     TimeString = TimeString+minute+":";
     if (second<10) {TimeString = TimeString+"0";}
     TimeString = TimeString+second;

} // fin funtion GET_TIME
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption
// fubnction para obtener los nombres de las columnas cuando se cambian la versiones de mtrackj 
function OBTENER_COLUMNS_LABEL() {

	selectWindow("Results"); 
	text = getInfo(); 
	lines = split(text, "\n"); 
	columns_label_array = split(lines[0], "\t"); 

	var	columns_label_length = lengthOf(columns_label_array);	
		
	for (i_col_label = 0; i_col_label < columns_label_length; i_col_label++) {
		if (columns_label_array[i_col_label] == titulo_result_coord_x) col_coord_label = true;
		if (columns_label_array[i_col_label] == label_trayectoria) col_coord_label = true;
		if (columns_label_array[i_col_label] == titulo_result_intensity) col_intensidad_label = true;
		}
		 
 	if (col_coord_label==false || col_track_label==false) DIALOGO_PICK_A_COLUMN(columns_label_array);

 	
   	
// 	if (type_graph == "Intensity"){
//		if (col_intensidad_label==false) DIALOGO_PICK_A_COLUMN(columns_label_array);
//	}



} // fin funtion obtener_columns_label
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion asignar los nombres de las columnas a analizar
function DIALOGO_PICK_A_COLUMN(columns_label_array) {
	
//	columns_label_array1 = columns_label_array;
//	columns_label_array2 = columns_label_array;
	
//	print("titulo_result_coord_x antes de elegir:", saved_titulo_result_coord_x);
//	print("titulo_result_coord_y antes de elegir:", saved_titulo_result_coord_y);
//	print("saved_label_trayectoria antes de elegir:", saved_label_trayectoria);
		
	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Configuration");

	// cuadro de dialogo valores de configuracion de video	

			Dialog.addMessage("# # #  Columns headings  # # #"); 
	Dialog.addChoice("Trajectory column:", columns_label_array, saved_label_trayectoria);	
	Dialog.addChoice("X coordinates column:", columns_label_array, saved_titulo_result_coord_x);
	Dialog.addChoice("Y coordinates column:", columns_label_array, saved_titulo_result_coord_y);
	
	if (type_graph == "Intensity") ¨{
			Dialog.addChoice("Intensity column:", columns_label_array, saved_titulo_result_intensity);
	}

	Dialog.show();

	label_trayectoria = Dialog.getChoice();
	titulo_result_coord_x = Dialog.getChoice();
	titulo_result_coord_y = Dialog.getChoice();
	if (type_graph == "Intensity") ¨{
			titulo_result_intensity = Dialog.getChoice();
	}

//	print("titulo_result_coord_x despues de elegir:", titulo_result_coord_x);
//	print("titulo_result_coord_y despues de elegir:", titulo_result_coord_y);
//	print("label_trayectoria despues de elegir:", label_trayectoria);
	
	saved_titulo_result_coord_x = titulo_result_coord_x;
	saved_titulo_result_coord_y = titulo_result_coord_y;
	saved_label_trayectoria = label_trayectoria;
	if (type_graph == "Intensity") ¨{
			saved_titulo_result_intensity = titulo_result_intensity;
	}


		
} // fin funtion DIALOGO_PICK_A_COLUMN
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para crear LA IMAGEN DEL RESULTADO CON LOS PUNTOS DE INICIO
function CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp) {

	// va a la funcion para crear una nueva imagen vacia
	CREAR_IMAGEN_BLACK(ini_temp, fin_temp); // va a la funcion
	
	// establece las coord x,y iniciales y finales_
	zoide_x_start = getResult(titulo_result_coord_x, ini_temp-1)*zuum;
	zoide_y_start = getResult(titulo_result_coord_y, ini_temp-1)*zuum;
	zoide_x_end = getResult(titulo_result_coord_x, fin_temp-1)*zuum;
	zoide_y_end = getResult(titulo_result_coord_y, fin_temp-1)*zuum;

	// escribe el nombre de la track
	setColor(255,255,255);
	setFont("Arial", 24, "Antialiased"); 
	drawString(label_trayectoria + " " + lbl_track_actual, ancho_imagen_result - 200, alto_imagen_result - 20); 	

	// Escribe el titulo d ela variable dibujada
	variable_dibujada = type_graph;
	setColor(255,255,255);
	setFont("Arial", 32, "Antialiased"); 
	drawString(variable_dibujada, 50, 50);

	
	// va a la funcion para dibujar el punto inicial
	DRAW_PUNTO_INICIO (zoide_x_start, zoide_y_start);

	// va a la funcion para dibujar el punto final
	DRAW_PUNTO_FINAL (zoide_x_end, zoide_y_end);

	if (analisis_por_area == true) DRAW_AREA_ANALISIS (zoide_x_start, zoide_y_start);
	
}// fin de la funcion
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para crear una nueva imagen vacia
function CREAR_IMAGEN_BLACK(ini_temp, fin_temp) {

	if (result_image_fixed_size_chk == false) SET_IMAGE_SIZE();

	// asigna el titulo de la imagen
	titulo_imagen = "LINES: Track: " + name_track + "// Start:" + ini_temp +"// end:" + fin_temp;

	// crea una nueva imagen negra de tamaño definido, se podria cambiar
	newImage(titulo_imagen, "RGB black", ancho_imagen_result, alto_imagen_result, 1);

} // fin de la funcion
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para dibujar el punto inicial
function DRAW_AREA_ANALISIS (zoide_x_start, zoide_y_start) {

	setColor(255,255,255);

	drawLine(0, zone_limit_inf, ancho_imagen_result, zone_limit_inf);
	drawLine(0, zone_limit_sup, ancho_imagen_result, zone_limit_sup);	

} // fin funcion
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato

//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para ajustar el tamaño de la imagena un rango variable
function SET_IMAGE_SIZE() {

	// el alto minimo d ela imagen es de 500 px
	alto_imagen_result = 500;

	x_size_max = 0;
	y_size_max = 0;
		
	for (i_image_size = 0; i_image_size < nResults; i_image_size++) {
		x_size_current = getResult(titulo_result_coord_x, i_image_size)*zuum;
		y_size_current = getResult(titulo_result_coord_y, i_image_size)*zuum;			
		if (x_size_max < x_size_current) x_size_max = x_size_current;
		if (y_size_max < y_size_current) y_size_max = y_size_current;
	}

	ancho_imagen_result = 350 + ((floor(x_size_max)/100) * 100);
	if (y_size_max > alto_imagen_result) alto_imagen_result = 500 + ((floor(x_size_max)/100) * 100);
	
} // fin function SET_IMAGE_SIZE
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para dibujar el punto inicial
function DRAW_PUNTO_INICIO (zoide_x_start, zoide_y_start) {

	setColor(255,255,255);
	dot_size=12;

	inicio_posicion_x = zoide_x_start - dot_size/2 + desfasaje_x;
	inicio_posicion_y = zoide_y_start - dot_size/2 + desfasaje_y;

//	fillOval(zoide_x_start - dot_size/2, zoide_y_start - dot_size/2, dot_size, dot_size);
//	drawOval(zoide_x_start - dot_size/2, zoide_y_start - dot_size/2, dot_size, dot_size); 
	drawOval(inicio_posicion_x, inicio_posicion_y, dot_size, dot_size); 

} // fin funcion
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para dibujar el punto final
function DRAW_PUNTO_FINAL (zoide_x_end, zoide_y_end) {

	setColor(255,255,255);
	dot_size=8;

	fin_posicion_x = zoide_x_end - dot_size/2 + desfasaje_x;
	fin_posicion_y = zoide_y_end - dot_size/2 + desfasaje_y;
	
//	drawOval(zoide_x_end - dot_size/2, zoide_y_end - dot_size/2, dot_size, dot_size);
//	fillOval(zoide_x_end - dot_size/2, zoide_y_end - dot_size/2, dot_size, dot_size);
	fillOval(fin_posicion_x, fin_posicion_y, dot_size, dot_size); 

} // fin funcion
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato
// funcion para concatenar imagenes y hacer un stack
function CONCATENAR_IMAGENES() {
	
	titulo_concatenado = "all_open title=[Imgaes stack: "+type_graph+"]"; // titulo personalizado
	run("Concatenate...", titulo_concatenado);	

} // fin funcion
//formatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformatoformato


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar las trayectorias con lineas
function DIBUJAR_LINEAS_ORIENTACION(ini_temp, fin_temp) {

	// crea la imagend el resultado y dibuja los pontos iniciales y finales
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp);

	// establece el grosor de la linea
	setLineWidth(2);
	
	// dibuja las lineas de conexon entre los puntos
	zoide_x_start = getResult(titulo_result_coord_x, ini_temp-1)*zuum + desfasaje_x;
	zoide_y_start = getResult(titulo_result_coord_y, ini_temp-1)*zuum + desfasaje_y;
	zoide_x_old = zoide_x_start;
	zoide_y_old = zoide_y_start; 
	
	for (i=ini_temp; i<fin_temp; i++) {
		zoide_x = getResult(titulo_result_coord_x, i)*zuum + desfasaje_x;
		zoide_y = getResult(titulo_result_coord_y, i)*zuum + desfasaje_y;
	
		angle = atan (abs(zoide_y - zoide_y_old) / abs(zoide_x - zoide_x_old)) * 360 / (2*PI);	// print("Punto: ", getResult("Point", i)," angulo: ", angle);	// log record
	
		if (angle<=90 && angle>=45 && (zoide_y-zoide_y_old)>=0) {
			orientation_temp = "orient_down";
//			setColor(255,0,0);
//			drawLine(zoide_x_old, zoide_y_old, zoide_x, zoide_y);
		} // fin del if
		
		else if (angle<=90 && angle>=45 && (zoide_y-zoide_y_old)<0) {
			orientation_temp = "orient_up";
//			setColor(0,255,0);
//			drawLine(zoide_x_old, zoide_y_old, zoide_x, zoide_y);
		} // fin del else if
	
		else if (angle<45 && angle>=0 && (zoide_x-zoide_x_old)<0) {
			orientation_temp = "orient_left";			
//			setColor(255,255,0);
//			drawLine(zoide_x_old, zoide_y_old, zoide_x, zoide_y);
		} // fin del else if
		
		else {
			orientation_temp = "orient_rigth";
//			setColor(0,0,255);
//			drawLine(zoide_x_old, zoide_y_old, zoide_x, zoide_y);	
		} // fin del else


		if (option_fuente_atractante == "Upper side") { // option_orientation = "Rigth side"
			if (orientation_temp == "orient_up") setColor (0,255,0); 
			if (orientation_temp == "orient_down") setColor (255,0,0);
			if (orientation_temp == "orient_left") setColor (0,0,255); // yellow (255,255,0)
			if (orientation_temp == "orient_rigth") setColor (0,0,255);  
		}
		else if (option_fuente_atractante == "Bottom side") { // option_orientation = "Rigth side"
			if (orientation_temp == "orient_up") setColor (255,0,0); 
			if (orientation_temp == "orient_down") setColor (0,255,0);
			if (orientation_temp == "orient_left") setColor (0,0,255); 
			if (orientation_temp == "orient_rigth") setColor (0,0,255); // yellow (255,255,0)  	
		}
		else if (option_fuente_atractante == "Left side") { // option_orientation = "Rigth side"
			if (orientation_temp == "orient_up") setColor (0,0,255); 
			if (orientation_temp == "orient_down") setColor (0,0,255); // yellow (255,255,0)
			if (orientation_temp == "orient_left") setColor (0,255,0); 
			if (orientation_temp == "orient_rigth") setColor (255,0,0);  			
		}
		else  { // option_orientation = "Rigth side"
			if (orientation_temp == "orient_up") setColor (0,0,255); // yellow (255,255,0)
			if (orientation_temp == "orient_down") setColor (0,0,255);
			if (orientation_temp == "orient_left") setColor (255,0,0); 
			if (orientation_temp == "orient_rigth") setColor (0,255,0);  			
		}

		// dibuja la linea
		drawLine(zoide_x_old, zoide_y_old, zoide_x, zoide_y);
		
		zoide_x_old = zoide_x; // reasigna el valor_old
		zoide_y_old = zoide_y;
	} // fin del for

	WRITE_LINES_REF();

} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
// Funcion escribir las referencias de colores de laslineas  
function WRITE_LINES_REF() {

	var alpha_degree_mod = "";
		
	wl_xi = 150; // posicion x del centro de circulo
	wl_yi = 200; // posicion y del centro de circulo
	alpha_degree = 0; // angulo

	h_length = 80; // largo de los lineas

	// inicia el bucle para dibujar las lineas de colores
	for (alpha_degree = 0.001; alpha_degree<360; alpha_degree+=10) {
		alpha_rad = (360 - alpha_degree) * 2 * PI / 360;
		// dibujo un circulo de lineas
		wl_yf = h_length * sin(alpha_rad) + wl_yi;
		wl_xf = h_length * cos(alpha_rad) + wl_xi;

		if (option_fuente_atractante == "Upper side") {
			if (alpha_degree > 45 && alpha_degree < 135) {setColor(0,255,0);}
			else if (alpha_degree > 225 && alpha_degree < 315) {setColor(255,0,0);}
			else {setColor(0, 0, 255);}
		} // fin del If
		else if (option_fuente_atractante == "Bottom side") {
			if (alpha_degree > 225 && alpha_degree < 315) {setColor(0,255,0);}
			else if (alpha_degree > 45 && alpha_degree < 135) {setColor(255,0,0);}
			else {setColor(0, 0, 255);}
		} // fin del else if
		else if (option_fuente_atractante == "Left side") {
			if (alpha_degree > 135 && alpha_degree < 225) {setColor(0,255,0);} // verde
			else if (alpha_degree > 0 && alpha_degree < 45 || alpha_degree > 315 && alpha_degree < 361) {setColor(255,0,0);} // rojo
			else {setColor(0, 0, 255);}
		} // fin del else if
		else if (option_fuente_atractante == "Rigth side") { 
			if (alpha_degree > 135 && alpha_degree < 225) {setColor(255,0,0);} // rojo
			else if (alpha_degree > 0 && alpha_degree < 45 || alpha_degree > 315 && alpha_degree < 361) {setColor(0,255,0);} // verde
			else {setColor(0, 0, 255);}
		} // fin del else if
		else {setColor(255,255,255);} // fin del else

		// dibuja las lineas del color correspondiente
		drawLine(wl_xi, wl_yi, wl_xf, wl_yf);	
		
	} // fin del if del bucle para dibujar las lineas

		setJustification("center");
		setFont("Arial", 32, "centered");
	
	if (option_fuente_atractante == "Upper side") {
		setColor(0, 255, 0);
		Overlay.drawString("towards", 90, 110, 0);
		setColor(255, 0, 0);
		Overlay.drawString("against", 95, 320, 0);
		setJustification("left");
	} // fin del if
	else if (option_fuente_atractante == "Bottom side") {
		setColor(0, 255, 0);
		Overlay.drawString("towards", 90, 320, 0);
		setColor(255, 0, 0);
		Overlay.drawString("against", 95, 110, 0);
		setJustification("left");
	} // fin del else if
	else if (option_fuente_atractante == "Rigth side") {
		setColor(0, 255, 0);
		Overlay.drawString("towards", 265, 270, 90);
		setColor(255, 0, 0);
		Overlay.drawString("against", 55, 265, 90);
		setJustification("left");
	} // fin del else if
	else if (option_fuente_atractante == "Left side") {
		setColor(0, 255, 0);
		Overlay.drawString("towards", 55, 270, 90);
		setColor(255, 0, 0);
		Overlay.drawString("against", 265, 265, 90);
		setJustification("left");
	} // fin del if
	else {} // fin del else
	Overlay.show;

	// toma el ID de la imagen
	imagen_antes_de_flatten = getImageID();

	// genera una copia de la imagen para estampar el titulo del overlay
	run("Flatten");

	// Seleccion y elimina la imagen sin estampar porque sino la duplica en el stack
	selectImage(imagen_antes_de_flatten);
	close();
	
} // fin function
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar puntos
function DIBUJAR_DOTS(ini_temp, fin_temp) {

	// crea la imagend el resultado y dibuja los pontos iniciales y finales
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp);
		

	// ajusta el punto final donde debe hacer el corte si le frecuencia es par o impar
	// si no se hace esta corrección salta un error cuando se modifica la frecuencia
	if (frame_fixed_track_zoide_chk == true) {
		fin_temp_corregido =  ini_temp + num_frame_fixed_track_zoide;
	}
	else {
		if (v_freq%2 == 0) { 
			fin_temp_corregido = fin_temp;
		}
		else {
			fin_temp_corregido = fin_temp - 1;	
		}
	}
	
	// dibuja los puntos intermedios
	for (i_dot = ini_temp; i_dot < fin_temp_corregido - 1; i_dot++) {
		zoide_x = getResult(titulo_result_coord_x, i_dot)*zuum + desfasaje_x; // agregue una variable de corrimiento desfasaje_x
		zoide_y = getResult(titulo_result_coord_y, i_dot)*zuum + desfasaje_y; // agregue una variable de corrimiento desfasaje_y
		
		setColor(0,255,255);
		dot_size = 4;
		fillOval(zoide_x - dot_size/2, zoide_y - dot_size/2, dot_size, dot_size);
	} // fin for
		
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para crear una table de resultados
function CREAR_TABLE_DF_RESUMEN() {
	
	title1 = "Fractal Dimension resume"; 
	title2 = "["+title1+"]"; 
	f=title2;	
	
	var1 = "Fractal Dimension";
	var2 = "";
	var3 = "";
	
	run("New... ", "name="+title2+" type=Table"); 
//	print(f,"\\Headings:"+label_trayectoria+"\t"+titulo_result_coord_x+"\t"+titulo_result_coord_y); 
	print(f,"\\Headings:"+" "+"\t"+label_trayectoria+"\t"+var1+"\t"+var2+"\t"+var3); 
	
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar puntos
function WRITE_TABLE_DF_RESUMEN() {
	
	title1 = "Fractal Dimension resume"; 
	title2 = "["+title1+"]"; 
	f=title2;	

	var1 = DF_promedio_track;
	var2 = "";
	var3 = "";
	
	print(f,i_order+"\t"+name_track+"\t"+var1+"\t"+var2+"\t"+var3);

	i_order++;
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para crear una table de resultados
function CREAR_TABLE_ORIENTACION_RESUMEN() {
	
	title1 = "Orientation resume"; 
	title2 = "["+title1+"]"; 
	f=title2;	
	
	var1 = "% orientado";
	var2 = "% random";
	var3 = "% repelido";
	
	run("New... ", "name="+title2+" type=Table"); 
//	print(f,"\\Headings:"+label_trayectoria+"\t"+titulo_result_coord_x+"\t"+titulo_result_coord_y); 
	print(f,"\\Headings:"+" "+"\t"+label_trayectoria+"\t"+var1+"\t"+var2+"\t"+var3); 
	
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar puntos
function WRITE_TABLE_ORIENTACION_RESUMEN() {
	
	title1 = "Orientation resume"; 
	title2 = "["+title1+"]"; 
	f=title2;	

	var1 = prop_track_orientado;
	var2 = prop_track_random;
	var3 = prop_track_repelido;
	
	print(f,i_order+"\t"+name_track+"\t"+var1+"\t"+var2+"\t"+var3);

	i_order++;
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para crear una table de resultados
function CREAR_TABLE_VELOCIDADES_RESUMEN() {
	
	title1 = "Velocities resume"; 
	title2 = "["+title1+"]"; 
	f=title2;	

	if (usar_escala_chk == false) {
	var1 = "VCL [px/s]";
	var2 = "VSL [px/s]";
	var3 = "VAP [px/s]";
	if (type_graph=="VAPi") var3 = "VAPi [px/s]"; // Esto tiene que estar despues de var3 porque la modifica instantanemanete
	}
	else if (usar_escala_chk == true) {
	var1 = "VCL [um/s]";
	var2 = "VSL [um/s]";
	var3 = "VAP [um/s]";
	if (type_graph=="VAPi") var3 = "VAPi [um/s]"; // Esto tiene que estar despues de var3 porque la modifica instantanemanete
	}
	else{}
	
	run("New... ", "name="+title2+" type=Table"); 
//	print(f,"\\Headings:"+label_trayectoria+"\t"+titulo_result_coord_x+"\t"+titulo_result_coord_y); 
	print(f,"\\Headings:"+" "+"\t"+label_trayectoria+"\t"+var1+"\t"+var2+"\t"+var3); 
	
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar puntos
function WRITE_TABLE_VELOCIDADES_RESUMEN() {
	
	title1 = "Velocities resume"; 
	title2 = "["+title1+"]"; 
	f=title2;	

	var1 = vcl_promedio_track;
	var2 = vsl_promedio_track;
	var3 = vap_promedio_track;
	
	print(f,i_order+"\t"+name_track+"\t"+var1+"\t"+var2+"\t"+var3);

	i_order++;
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar la orientacion en los puntos.
function DIBUJAR_ORIENTACION(ini_temp, fin_temp) {

	// crea la imagend el resultado y dibuja los pontos iniciales y finales
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp);	// print("ini_temp", ini_temp, "fin_temp", fin_temp); // log record
	
// !!!!!!!!!!!! LO QUE ESTA DEBAJO DE ESTE CARTEL SACAR PORQUE DEJA DE FUNCIONAR !!!!!!!!!!!!!
	// calculo de la distancia en puntos que se va a calcular la Vel
	vel_len = floor(v_run*v_freq);	// print("vel_len", vel_len); // log record
		
	// creacion de arrays y variables relacionadas
	// esto asigna el tamaño del array, si es un numero fijo o si es variable
	if (frame_fixed_track_zoide_chk == true) {
		array_len = num_frame_fixed_track_zoide; // le puse -1 para ajustar bien el tamaño del Array que siempre empieza en cero y no en uno
	}
	else {
		array_len = (fin_temp - ini_temp - vel_len);	// print("array_len", array_len);	// log record
	}

	if (array_len>0) { // este if corrige un error que aparece cuando la cantidad de puntos trackeados no alcanza para dibujar las trayectorias promedios
		
		// CREAR Y UPDATE!!! TODOS LOS ARRAY EN LOS CALCULOS DE VELOCIDADES
		a_orientation_coord_x = newArray(array_len); // crea un array para almacenar las coordenadas x del punto
		a_orientation_coord_y = newArray(array_len); // crea un array para almacenar las coordenadas y del punto
		a_orientation_value = newArray(array_len); // crea un array para almacenar el valor VCL del punto
	 			
		i_arr_temp = 0; // inicia el contador de los array %%%&$%&#$"#$%"#$%"# tiene que ser 0 !!
	// !!!!!!!!!!!! LO QUE ESTA ENCIMA DE ESTE CARTEL NO SACAR PORQUE DEJA DE FUNCIONAR !!!!!!!!!!!!!
		
	// establece el numero de orden donde empiezan a dibujarse los valores de ORIENTACION
	num_orden_inicio_track = ini_temp + floor(vel_len/2);


	// ajusta el punto final donde debe hacer el corte si le frecuencia es par o impar
	// si no se hace esta corrección salta un error cuando se modifica la frecuencia
	if (frame_fixed_track_zoide_chk == true) {
		fin_temp_corregido =  num_orden_inicio_track + array_len;
	}
	else {
		if (v_freq%2 == 0) { 
			fin_temp_corregido = fin_temp - floor(vel_len/2);
		}
		else {
			fin_temp_corregido = fin_temp - floor(vel_len/2) - 1;	
		}
	}


		// inicia el bucle para evaluar la ORIENTACION en los TODOS los PUNTOS DE LA TRAYECTORIA DEL ZOIDE
		for (i_ori = ini_temp + floor(vel_len/2); i_ori < fin_temp_corregido; i_ori++) {  // inicio del for calcular la ORIENTACION en los TODOS los PUNTOS DE LA TRAYECTORIA DEL ZOIDE y los asigna al ARRAY

			// aca es donde los voy a dibujar al punto		
			a_orientation_coord_x[i_arr_temp] = getResult(titulo_result_coord_x, i_ori-1)*zuum; // asigna la coord x donde se va a dibujar la variable
			a_orientation_coord_y[i_arr_temp] = getResult(titulo_result_coord_y, i_ori-1)*zuum; // asigna la coord y donde se va a dibujar la variable
	
			// esto determina donde empieza y termina EL espermatozoide que esta analizando ahora
			
			// establece donde comienza el run
			ini_run = i_ori - floor(vel_len/2); // print("ini_run", ini_run); // log record
			// establece donde termina el run
			fin_run = i_ori + floor(vel_len/2); // print("fin_run", fin_run); // log record
	
			// INICIO CALCULO ORIENTACION	
			
			// asignacion de coordenadas iniciales y finales
			ori_x_temp_ini = getResult(titulo_result_coord_x, ini_run-1)*zuum;	// print("ori_x_temp_ini:", ori_x_temp_ini-1); // log record
			ori_x_temp_fin = getResult(titulo_result_coord_x, fin_run-1)*zuum; // print("ori_x_temp_fin:", ori_x_temp_fin-1); // log record
			ori_y_temp_ini = getResult(titulo_result_coord_y, ini_run-1)*zuum; // print("ori_y_temp_ini:", ori_y_temp_ini-1); // log record
			ori_y_temp_fin = getResult(titulo_result_coord_y, fin_run-1)*zuum; // print("ori_y_temp_fin:", ori_y_temp_fin-1); // log record		
			
			delta_x_ori = ori_x_temp_fin - ori_x_temp_ini; // print("delta_x_ori:", delta_x_ori); // log record
			delta_y_ori = ori_y_temp_fin - ori_y_temp_ini; // print("delta_y_ori:", delta_y_ori); // log record
	
			angle = atan (abs(delta_y_ori) / abs(delta_x_ori)) * 360 / (2*PI);	// print("Punto: ", getResult("Point", i)," angulo: ", angle);	// log record
		
			// Esto asigna hacia donde esta orientado el run
			if (angle<=90 && angle>=45 && delta_y_ori>=0) orientation_temp = "orient_down";	
			else if (angle<=90 && angle>=45 && delta_y_ori<0) orientation_temp = "orient_up";
			else if (angle<45 && angle>=0 && delta_x_ori<0) orientation_temp = "orient_left";			
			else {orientation_temp = "orient_rigth";}
	
			// aca asigna el valor de orientacion en funcion de la posicion del atractante
			if (option_fuente_atractante == "Upper side") { // option_orientation = "Rigth side"
				if (orientation_temp == "orient_up") a_orientation_value[i_arr_temp] = "towards"; 
				else if (orientation_temp == "orient_down") a_orientation_value[i_arr_temp] = "against";
				else if (orientation_temp == "orient_left") a_orientation_value[i_arr_temp] = "perpendicular"; 
				else if (orientation_temp == "orient_rigth") a_orientation_value[i_arr_temp] = "perpendicular"; 
				else {} 
			}
			else if (option_fuente_atractante == "Bottom side") { // option_orientation = "Rigth side"
				if (orientation_temp == "orient_up") a_orientation_value[i_arr_temp] = "against"; //red
				else if (orientation_temp == "orient_down") a_orientation_value[i_arr_temp] = "towards"; // green
				else if (orientation_temp == "orient_left") a_orientation_value[i_arr_temp] = "perpendicular"; 
				else if (orientation_temp == "orient_rigth") a_orientation_value[i_arr_temp] = "perpendicular"; // yellow (255,255,0)  	
				else {}
				}
			else if (option_fuente_atractante == "Left side") { // option_orientation = "Rigth side"
				if (orientation_temp == "orient_up") a_orientation_value[i_arr_temp] = "perpendicular"; 
				else if (orientation_temp == "orient_down") a_orientation_value[i_arr_temp] = "perpendicular"; // yellow (255,255,0)
				else if (orientation_temp == "orient_left") a_orientation_value[i_arr_temp] = "towards"; 
				else if (orientation_temp == "orient_rigth") a_orientation_value[i_arr_temp] = "against";  			
				else {}
			}
			else if (option_fuente_atractante == "Rigth side") { // option_orientation = "Rigth side"
				if (orientation_temp == "orient_up") a_orientation_value[i_arr_temp] = "perpendicular"; // yellow (255,255,0)
				else if (orientation_temp == "orient_down") a_orientation_value[i_arr_temp] = "perpendicular";
				else if (orientation_temp == "orient_left") a_orientation_value[i_arr_temp] = "against"; 
				else if (orientation_temp == "orient_rigth") a_orientation_value[i_arr_temp] = "towards";  			
				else {}
			}
			else {}
	
			// incrementos necesarios al finalizar el loop
			i_arr_temp++;	// incrementa la posicion del array
		} // fin del for para calcular la ORIENTACION en los TODOS los PUNTOS DE LA TRAYECTORIA DEL ZOIDE y los asigna al ARRAY
	
		
		// limpia las variables
		total_track_orientado = 0;
		total_track_random = 0;
		total_track_repelido = 0;
			
		// Representa los valores de ORIENTACION y estima los valores de % orientado, % random y % repelido que se tabulan en "Orientation resume"
		for (i=1; i<a_orientation_value.length; i++) {
			var_value = a_orientation_value[i];
			var_coord_x = a_orientation_coord_x[i] + desfasaje_x; // le agregue el termino de desfasaje para poder correr las tracks a una zona limpia
			var_coord_y = a_orientation_coord_y[i] + desfasaje_y; // le agregue el termino de desfasaje para poder correr las tracks a una zona limpia			
	
			// asigna los colores en funcion del valor de la variable
			if (var_value=="towards") {
				total_track_orientado++;
				setColor(0,255,0);
			}
			else if (var_value=="perpendicular") {
				total_track_random++;
				setColor(0,0,255);		
			}
			else if (var_value=="against") {
				total_track_repelido++;
				setColor(255,0,0);		
			}
			else {255,255,255};

			// establece el tamaño de punto
			dot_size=4;
					
			// dibuja el punto con el color asignado
			fillOval(var_coord_x - dot_size/2, var_coord_y - dot_size/2, dot_size, dot_size);
			
		} // fin del for 
		
			// calcula las proporciones de orientados, random y repelidos
			total_track = (total_track_orientado + total_track_random + total_track_repelido);
			prop_track_orientado = round((total_track_orientado / total_track) * 100);
			prop_track_random = round((total_track_random / total_track) * 100);
			prop_track_repelido = round((total_track_repelido / total_track) * 100);
			
	} // fin del if para chequear que hay puntos suficientes  para analizar "array_len > 0"

	WRITE_TABLE_ORIENTACION_RESUMEN();
	
}// fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar VCL relativa al valor anterior
// una suerte de calculo de aceleracion??
function DIBUJAR_DIF_VCL(ini_temp, fin_temp) {

	vcl_old = 0; // empieza con un valor de VCL de cero, NO BORRAR

	vcl_len = floor(v_run*v_freq); // distancia entre los puntos en los que se va a calcular la VCL

	// crea la imagend el resultado y dibuja los pontos iniciales y finales
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp);
				
	// dibuja los puntos intermedios
	for (i_vcl = ini_temp + floor (vcl_len/2); i_vcl < fin_temp-floor(vcl_len/2)-1; i_vcl++) {
		zoide_x = getResult(titulo_result_coord_x, i_vcl)*zuum + desfasaje_x; // establece la posicion x del punto de vcl promedio,le agregue un desfasaje para acomodarlo en la imagen
		zoide_y = getResult(titulo_result_coord_y, i_vcl)*zuum + desfasaje_y; // establece la posicion y del punto de vcl promedio,le agregue un desfasaje para acomodarlo en la imagen
				
// 		aca poner el calculo de la vcl
// 		para cada punto voy a tomar una vcl promedio del run, 
//		y tomando el las coordenadas x,y del punto actual como el centro de ese run

	track_len_total = 0; // resetea el valor para volver a valcularlo
	track_len_parcial = 0; // resetea el valor para volver a valcularlo

	ini_run = i_vcl - floor(vcl_len/2); // establece el numero de registro donde comienza el run
	fin_run = i_vcl + floor(vcl_len/2); // establece el numero de registro donde termina el run
	
	for (i_vcl_len = ini_run; i_vcl_len < fin_run; i_vcl_len++) {
		// calculo de la distancia recorrida en el run
//new
		x_parcial_f = getResult(titulo_result_coord_x, i_vcl_len+1)*zuum;
		x_parcial_i = getResult(titulo_result_coord_x, i_vcl_len)*zuum;		

		y_parcial_f = getResult(titulo_result_coord_y, i_vcl_len+1)*zuum;
		y_parcial_i = getResult(titulo_result_coord_y, i_vcl_len)*zuum;

		delta_x_parcial = x_parcial_f - x_parcial_i;
		delta_y_parcial = y_parcial_f - y_parcial_i;
// end new
		
//		delta_x_parcial = (getResult(titulo_result_coord_x, i_vcl_len+1)) - (getResult(titulo_result_coord_x, i_vcl_len));
//		delta_y_parcial = (getResult(titulo_result_coord_y, i_vcl_len+1)) - (getResult(titulo_result_coord_y, i_vcl_len));
		
		track_len_parcial = sqrt((pow(delta_x_parcial, 2) + pow(delta_x_parcial, 2))); 
		track_len_total = track_len_total + track_len_parcial;	
	} // fin del for

	// calculo del valor de VCL actual
	vcl_value = track_len_total/v_run;
		
	// asignacion de colores segun los cambios en la velocidad	
	if (vcl_value > (vcl_old + (vcl_old * v_dif_vcl))) {
		dot_size=4;
		setColor(0,255,0);
	}
	else if (vcl_value < (vcl_old - (vcl_old * v_dif_vcl))) {
		dot_size=4;
		setColor(255,0,0);
	}
	else {
		dot_size=2;
		setColor(0,0,255);
	}
	
	// dibuja el punto con el color del cambio de VCL
	fillOval(zoide_x - dot_size/2, zoide_y - dot_size/2, dot_size, dot_size);

	vcl_old = vcl_value; // asigna un nuevo valor viejo
	} // fin for
	
	// va a la funcion para escribir las referencias
	WRITE_REF_DIF_VCL();
	
} // fin funcion
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
// Funcion para escribir la referencia de colores de la VCL  
function WRITE_REF_DIF_VCL() {

	ref_string = "";
	dot_size = 16;
	setFont("Arial", 30, "Antialiased");
	x_ref_dif_vcl = 50;

	// green dot
	y_ref_dif_vcl = 100;
	setColor(255, 255, 255);
	fillOval(x_ref_dif_vcl, y_ref_dif_vcl, dot_size, dot_size);
	drawString(">", x_ref_dif_vcl+25, y_ref_dif_vcl+25);
	ref_string = "  > " + (v_dif_vcl*100) + "%";
	drawString(ref_string, x_ref_dif_vcl+75, y_ref_dif_vcl+25);

	setColor(0, 255, 0);
	fillOval(x_ref_dif_vcl+50, y_ref_dif_vcl, dot_size, dot_size);
	
	// blue dot
	y_ref_dif_vcl +=50;
	setColor(255, 255, 255);
	fillOval(x_ref_dif_vcl, y_ref_dif_vcl, dot_size, dot_size);
	drawString(">", x_ref_dif_vcl+25, y_ref_dif_vcl+25);
	ref_string = "  < " + (v_dif_vcl*100) + "% >";
	drawString(ref_string, x_ref_dif_vcl+75, y_ref_dif_vcl+25);
		
	setColor(0, 0, 255);
	fillOval(x_ref_dif_vcl+50, y_ref_dif_vcl, dot_size, dot_size);

	// red dot
	y_ref_dif_vcl +=50;
	setColor(255, 255, 255);
	fillOval(x_ref_dif_vcl, y_ref_dif_vcl, dot_size, dot_size);
	drawString(">", x_ref_dif_vcl+25, y_ref_dif_vcl+25);
	ref_string = "  < " + (v_dif_vcl*100) + "%";
	drawString(ref_string, x_ref_dif_vcl+75, y_ref_dif_vcl+25);
		
	setColor(255, 0, 0);
	fillOval(x_ref_dif_vcl+50, y_ref_dif_vcl, dot_size, dot_size);
		
} // fin function
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// Funcion para calcular las VELOCIDADES usando array para almacenar los datos  
// ini_temp y fin_temp toman los valores de ini_track y fin_track pasados al llamar la función

function DIBUJAR_VELOCIDADES(ini_temp, fin_temp) {

	// crea la imagend el resultado y dibuja los pontos iniciales y finales
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp);	// print("ini_temp", ini_temp, "fin_temp", fin_temp); // log record
	
// !!!!!!!!!!!! LO QUE ESTA DEBAJO DE ESTE CARTEL SACAR PORQUE DEJA DE FUNCIONAR !!!!!!!!!!!!!
	// calculo de la distancia en puntos que se va a calcular la VCL
	vel_len = floor(v_run*v_freq);	// print("vel_len", vel_len); // log record


	// esto asigna el tamaño del array, si es un numero fijo o si es variable
	if (frame_fixed_track_zoide_chk == true) {
		array_len = num_frame_fixed_track_zoide; // le puse -1 para ajustar bien el tamaño del Array que siempre empieza en cero y no en uno
	}
	else {
		array_len = (fin_temp - ini_temp - vel_len);	// print("array_len", array_len);	// log record
	}
	
	// creacion de arrays y variables relacionadas
	if (array_len>0) { // este if corrige un error que aparece cuando la cantidad de puntos trackeados no alcanza para dibujar las trayectorias promedios
		
		// CREAR Y UPDATE!!! TODOS LOS ARRAY EN LOS CALCULOS DE VELOCIDADES
		a_vel_coord_x = newArray(array_len); // crea un array para almacenar las coordenadas x del punto
		a_vel_coord_y = newArray(array_len); // crea un array para almacenar las coordenadas y del punto
		a_vel_coord_x_VAP = newArray(array_len); // crea un array para almacenar las coordenadas x del punto
		a_vel_coord_y_VAP = newArray(array_len); // crea un array para almacenar las coordenadas y del punto
		a_vcl_z_prom = newArray(array_len); // crea un array para almacenar el valor VCL del punto
		a_vsl_z_prom = newArray(array_len); // crea un array para almacenar el valor VSL del punto

	if (frame_fixed_track_zoide_chk == true) {
			if ((array_len - rango_vap) > 1)  a_vap_z_prom = newArray(array_len); // crea un array para almacenar el valor VAP del punto // le agregue un if para omitir los valores que dan negativos hasta solucionarlo bien
	}
	else {
//		if ((array_len - rango_vap) > 1){ // 2017-06-09 le agregue >= 1
		if ((array_len - rango_vap) >= 1){
			a_vap_z_prom = newArray(array_len - rango_vap); // crea un array para almacenar el valor VAP del punto // le agregue un if para omitir los valores que dan negativos hasta solucionarlo bien
			a_vap_z_prom_empty == false;
		}
		else {
			a_vap_z_prom = newArray(0);	// 2017-06-19 lo agregue porque me tira un error si es negativo o cero que hag una array = 0
			a_vap_z_prom_empty == true;
		}
	}
	 			
		i_arr_temp = 0; // inicia el contador de los array %%%&$%&#$"#$%"#$%"# tiene que ser 0 !!
	// !!!!!!!!!!!! LO QUE ESTA ENCIMA DE ESTE CARTEL NO SACAR PORQUE DEJA DE FUNCIONAR !!!!!!!!!!!!!
		
/*		2017-06-19 Esto lo reemplacce por otras lineas de abajo para que calcule todas las velocidades y escriba todos los promedios
  		
 		if (type_graph == "VCL" || type_graph == "VSL") {
			// va a la funcion para calcular los ARRAY de las distintos tipos de VELOCIDADES
			ARRAY_VELOCIDADES(a_vel_coord_x, a_vel_coord_y, a_vcl_z_prom, a_vsl_z_prom, i_arr_temp, array_len);
			WRITE_TABLE_VELOCIDADES_RESUMEN();
		}
		
		if (type_graph == "VAP") {
			// va a la funcion para escribir las coordenadas x,y de la vap
			WRITE_VAP_COORD_IN_RESULTS(ini_temp, fin_temp);
			ARRAY_VAP(a_vel_coord_x, a_vel_coord_y, a_vap_z_prom, i_arr_temp, array_len);			
			WRITE_TABLE_VELOCIDADES_RESUMEN();
		}		

*/

		// va a la funcion para calcular los ARRAY de las distintos tipos de la VCL y la VSL
			ARRAY_VELOCIDADES(a_vel_coord_x, a_vel_coord_y, a_vcl_z_prom, a_vsl_z_prom, i_arr_temp, array_len, vel_len);

		//Escribe los valores de coordenadas para calcular la vap
			WRITE_VAP_COORD_IN_RESULTS(ini_temp, fin_temp);
			
		// va a la funcion para calcular los ARRAY de la VAP		
			ARRAY_VAP(a_vel_coord_x_VAP, a_vel_coord_y_VAP, a_vap_z_prom, i_arr_temp, array_len, vel_len);		

		// va a la funcion para escribir las velocidades promedio
			WRITE_TABLE_VELOCIDADES_RESUMEN();
	
				
		// Representa los valores de VCL 
		if (type_graph == "VCL") {
			// va la FUNCTION par dibujar lo puntos de la VCL RELATIVA con lut y le transfiere los array
			DIBUJAR_DOTS_COLOR(a_vel_coord_x, a_vel_coord_y, a_vcl_z_prom, array_len); 						
		} // fin if "dibujar VCL"
	
		// Representa los valores de VSL  
		if (type_graph == "VSL") {
			// va la FUNCTION par dibujar lo puntos de la VSL con lut y le transfiere los array
			DIBUJAR_DOTS_COLOR(a_vel_coord_x, a_vel_coord_y, a_vsl_z_prom, array_len); 	
		} // fin if "dibujar VSL"
	
		// Representa los valores de VSL  
		if (type_graph == "VAP" || type_graph=="VAPi") {
			// va la FUNCTION par dibujar lo puntos de la VAP con lut y le transfiere los array
			DIBUJAR_DOTS_COLOR(a_vel_coord_x, a_vel_coord_y, a_vap_z_prom, array_len); 		
		} // fin if "dibujar VSL"
		
		//	Array.print(a_vcl_z_prom); // log record
	} // fin del if para chequear que hay puntos suficientes  para analizar "array_len > 0"
	
} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// Funcion para dibujar Intensidades usando array para almacenar los datos  
// ini_temp y fin_temp toman los valores de ini_track y fin_track pasados al llamar la función

function DIBUJAR_INTENSIDAD(ini_temp, fin_temp) {

	// crea la imagend el resultado y dibuja los pontos iniciales y finales
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp);	// print("ini_temp", ini_temp, "fin_temp", fin_temp); // log record
	
// !!!!!!!!!!!! LO QUE ESTA DEBAJO DE ESTE CARTEL SACAR PORQUE DEJA DE FUNCIONAR !!!!!!!!!!!!!
	// calculo de la distancia en puntos que se va a calcular la VCL
	vel_len = floor(v_run*v_freq);	// print("vel_len", vel_len); // log record


	// esto asigna el tamaño del array, si es un numero fijo o si es variable
	if (frame_fixed_track_zoide_chk == true) {
		array_len = num_frame_fixed_track_zoide; // le puse -1 para ajustar bien el tamaño del Array que siempre empieza en cero y no en uno
	}
	else {
		array_len = (fin_temp - ini_temp - vel_len);	// print("array_len", array_len);	// log record
	}
	
	// creacion de arrays y variables relacionadas
	if (array_len>0) { // este if corrige un error que aparece cuando la cantidad de puntos trackeados no alcanza para dibujar las trayectorias promedios
		
		// CREAR Y UPDATE!!! TODOS LOS ARRAY EN LOS CALCULOS DE intensidades
		a_intensity_coord_x = newArray(array_len); // crea un array para almacenar las coordenadas x del punto
		a_intensity_coord_y = newArray(array_len); // crea un array para almacenar las coordenadas y del punto
		a_intensity_value = newArray(array_len); // crea un array para almacenar el valor intensidad del punto

	 			
		i_arr_temp = 0; // inicia el contador de los array %%%&$%&#$"#$%"#$%"# tiene que ser 0 !!
	// !!!!!!!!!!!! LO QUE ESTA ENCIMA DE ESTE CARTEL NO SACAR PORQUE DEJA DE FUNCIONAR !!!!!!!!!!!!!
		

		// va a la funcion para calcular los ARRAY de las distintos tipos de la VCL y la VSL
			ARRAY_INTENSIDADES(a_intensity_coord_x, a_intensity_coord_y, a_intensity_value, i_arr_temp, array_len);

				
		// Representa los valores de Intensidad 
		if (type_graph == "Intensity") {
			// va la FUNCTION par dibujar lo puntos de la VCL RELATIVA con lut y le transfiere los array
			DIBUJAR_DOTS_COLOR(a_intensity_coord_x, a_intensity_coord_y, a_intensity_value, array_len); 						
		} // fin if "dibujar Intensidad"
	
	
		//	Array.print(a_vcl_z_prom); // log record
	} // fin del if para chequear que hay puntos suficientes  para analizar "array_len > 0"
	
} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para hacer los array de Intensidades
function ARRAY_INTENSIDADES(a_intensity_coord_x, a_intensity_coord_y, a_intensity_value, i_arr_temp, array_len) {

var	contador_de_points_local = 0; // esto lo uso como divisor para estimar la vcl promedio de la track

	// establece el numero de orden donde empiezan a dibujarse los valores de VEL
	num_orden_inicio_track = ini_temp + floor(vel_len/2);

//	print("#_inicio_track", ini_temp); // log record
//	print("inicio_escritura_datos_track", num_orden_inicio_track); // log record
	
	
	// ajusta el punto final donde debe hacer el corte si le frecuencia es par o impar
	// si no se hace esta corrección salta un error cuando se modifica la frecuencia
	if (frame_fixed_track_zoide_chk == true) {
		fin_temp_corregido =  num_orden_inicio_track + array_len;
	}
	else {
		if (v_freq%2 == 0) { 
			fin_temp_corregido = fin_temp - floor(vel_len/2);
		}
		else {
			fin_temp_corregido = fin_temp - floor(vel_len/2) - 1;	
		}
	}

	
	// inicia el bucle para evaluar la INT en los TODOS los zoides
	for (i_int = ini_temp + floor(vel_len/2); i_int < fin_temp_corregido; i_int++) {  // le saque el -1
				
		zoide_x = getResult(titulo_result_coord_x, i_int-1)*zuum; // asigna la coord x donde se va a dibujar la VEL
		zoide_y = getResult(titulo_result_coord_y, i_int-1)*zuum; // asigna la coord y donde se va a dibujar la VEL
		zoide_intensity = getResult(titulo_result_intensity, i_int-1); // asigna la intensidad
		 
		a_intensity_coord_x[i_arr_temp] = zoide_x; // asigna la coordena x del punto de intensidad
		a_intensity_coord_y[i_arr_temp] = zoide_y; // aasigna la coordena y del punto de intensidad
		a_intensity_value[i_arr_temp] = zoide_intensity; // asigna la intensidad del punto
	

		// incrementos necesarios al finalizar el loop
		contador_de_points_local++; // imcrementa el divisor de las velocidades promedio
		i_arr_temp++;	// incrementa la posicion del array
	} // fin for INT en los TODOS los zoides

	
	return a_intensity_coord_x;
	return a_intensity_coord_y;
	return a_intensity_value;
	return array_len;
	return num_orden_inicio_track;

} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar otra variable
function DIBUJAR_LINEARIDAD(ini_temp, fin_temp) {

	// va a la funcion para crear una nueva imagen vacia
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp); // va a la funcion
	
	// calculo de la distancia en puntos que se va a calcular la VCL
	vel_len = floor(v_run*v_freq);

	// esto permite posicionar el lugar del resultado donde se escriben los resultados
	num_orden_inicio_track = ini_temp + floor(vel_len/2);

	// esto asigna el tamaño del array, si es un numero fijo o si es variable
	if (frame_fixed_track_zoide_chk == true) {
		array_len = num_frame_fixed_track_zoide; // le puse -1 para ajustar bien el tamaño del Array que siempre empieza en cero y no en uno
	}
	else {
		array_len = (fin_temp - ini_temp - vel_len);	// print("array_len", array_len);	// log record
	}
	
	if (array_len>0) { // este if corrige un error que aparece cuando la cantidad de puntos trackeados no alcanza para dibujar las trayectorias promedios

		a_vel_coord_x = newArray(array_len); // crea un array para almacenar las coordenadas x del punto
		a_vel_coord_y = newArray(array_len); // crea un array para almacenar las coordenadas y del punto
		a_vcl_z_prom = newArray(array_len); // crea un array para almacenar el valor vcl del punto
		a_vsl_z_prom = newArray(array_len); // crea un array para almacenar el valor vcl del punto
	
		i_arr_temp = 0; // iicia el contador de los array %%%&$%&#$"#$%"#$%"# tiene que ser 0 !!
	
		// va a la funcion para crear los array de las velocidades 
		ARRAY_VELOCIDADES(a_vel_coord_x, a_vel_coord_y, a_vcl_z_prom, a_vsl_z_prom, i_arr_temp, array_len, vel_len);
	
		a_lin_prom = newArray(array_len); // crea un array para almacenar el valor de LIN del punto		
	
		for (i_arr_temp = 0; i_arr_temp < array_len; i_arr_temp++) {
			a_lin_prom[i_arr_temp] = a_vsl_z_prom[i_arr_temp] / a_vcl_z_prom[i_arr_temp];	// print("punto:", i_arr_temp, "; vsl:", a_vsl_z_prom[i_arr_temp], "/ vcl:", a_vcl_z_prom[i_arr_temp],"= lin:", a_lin_prom[i_arr_temp]);	// log record

			// escribe en resultados el valor de Linearidad calculado para chequeo, se puede sacar cuando este verificado
			posicion_tabla_result = num_orden_inicio_track + i_arr_temp - 1;
//				print("#_posicion", posicion_tabla_result + 1); // log record
			setResult("LIN", posicion_tabla_result, a_lin_prom[i_arr_temp]); //log result record
		}
	
		// va la FUNCTION par dibujar lo puntos de color y le transfiere los array
		DIBUJAR_DOTS_COLOR(a_vel_coord_x, a_vel_coord_y, a_lin_prom, array_len);	
	
	} // fin del if para chequear que hay puntos suficientes  para analizar "array_len > 0"
		
} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para dibujar otra variable
function DIBUJAR_DF(ini_temp, fin_temp) {

DF_promedio_track = 0;
DF_sumatoria_track = 0;
contador_de_points_local = 0;

	// va a la funcion para crear una nueva imagen vacia
	CREAR_IMAGEN_RESULTADO(ini_temp, fin_temp); // va a la funcion
	
	// calculo de la distancia en puntos que se va a calcular la DF
	vel_len = floor(v_run*v_freq);

	// esto permite posicionar el lugar del resultado donde se escriben los resultados
	num_orden_inicio_track = ini_temp + floor(vel_len/2);
	
	// esto asigna el tamaño del array, si es un numero fijo o si es variable
	if (frame_fixed_track_zoide_chk == true) {
		array_len = num_frame_fixed_track_zoide; // le puse -1 para ajustar bien el tamaño del Array que siempre empieza en cero y no en uno
	}
	else {
		array_len = (fin_temp - ini_temp - vel_len);	// print("array_len", array_len);	// log record
	}
	
	if (array_len>0) { // este if corrige un error que aparece cuando la cantidad de puntos trackeados no alcanza para dibujar las trayectorias promedios

		a_vel_coord_x = newArray(array_len); // crea un array para almacenar las coordenadas x del punto
		a_vel_coord_y = newArray(array_len); // crea un array para almacenar las coordenadas y del punto
		a_vcl_z_prom = newArray(array_len); // crea un array para almacenar el valor vcl del punto
		a_vsl_z_prom = newArray(array_len); // crea un array para almacenar el valor vcl del punto
	
		i_arr_temp = 0; // iicia el contador de los array %%%&$%&#$"#$%"#$%"# tiene que ser 0 !!
	
		// va a la funcion para crear los array de las velocidades 
		ARRAY_VELOCIDADES(a_vel_coord_x, a_vel_coord_y, a_vcl_z_prom, a_vsl_z_prom, i_arr_temp, array_len, vel_len);
	
		a_DF_prom = newArray(array_len); // crea un array para almacenar el valor de DF del punto		
	
		for (i_arr_temp = 0; i_arr_temp < array_len; i_arr_temp++) {
			DF_value = log(vel_len) / (log(vel_len) + log(a_vsl_z_prom[i_arr_temp] / a_vcl_z_prom[i_arr_temp]));	// print("punto:", i_arr_temp, "; vsl:", a_vsl_z_prom[i_arr_temp], "/ vcl:", a_vcl_z_prom[i_arr_temp],"= lin:", a_lin_prom[i_arr_temp]);	// log record
			
			// Corrije el DF si se hace muy grande o si es menor que cero (valores de LIN<0,1 dan valores negativos de DF), lo convierte en 2
			if (DF_value > 2 || DF_value < 0) DF_value = 2; 
			
			a_DF_prom[i_arr_temp] = DF_value;
			
			// esto va sumando los DF
			DF_sumatoria_track = DF_sumatoria_track + DF_value;
			
			// escribe en resultados el valor de DF calculado para chequeo, se puede sacar cuando este verificado
			posicion_tabla_result = num_orden_inicio_track + i_arr_temp - 1;
	//			print("#_posicion", posicion_tabla_result + 1); // log record
			setResult("Fractal Dimension", posicion_tabla_result, a_DF_prom[i_arr_temp] ); //log result record

			contador_de_points_local++;
		}
	
		DF_promedio_track = DF_sumatoria_track / contador_de_points_local;			

		// va la FUNCTION par dibujar lo puntos de color y le transfiere los array
		DIBUJAR_DOTS_COLOR(a_vel_coord_x, a_vel_coord_y, a_DF_prom, array_len);	
	
	} // fin del if para chequear que hay puntos suficientes  para analizar "array_len > 0"

	WRITE_TABLE_DF_RESUMEN();
} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
// Funcion para escribir la referencia de colores de la VCL  
function WRITE_REF_DIMENSION_FRACTAL() {

	ref_string = "";
	dot_size = 16;
	setFont("Arial", 30, "Antialiased");
	x_ref_dif_vcl = 50;

	// green dot
	y_ref_dif_vcl = 100;
	setColor(0, 255, 0);
	fillOval(x_ref_dif_vcl, y_ref_dif_vcl, dot_size, dot_size);
	setColor(255, 255, 255);
	drawString("Lin", x_ref_dif_vcl+25, y_ref_dif_vcl+25);
	
	// blue dot
	y_ref_dif_vcl +=50;
	setColor(0, 0, 255);
	fillOval(x_ref_dif_vcl, y_ref_dif_vcl, dot_size, dot_size);
	setColor(255, 255, 255);
	drawString("Tran", x_ref_dif_vcl+25, y_ref_dif_vcl+25);

	// red dot
	y_ref_dif_vcl +=50;
	setColor(255, 0, 0);
	fillOval(x_ref_dif_vcl, y_ref_dif_vcl, dot_size, dot_size);
	setColor(255, 255, 255);
	drawString("HA", x_ref_dif_vcl+25, y_ref_dif_vcl+25);
		
} // fin function
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para  calcular los valores y hacer los array de velocidades
function ARRAY_VELOCIDADES(a_vel_coord_x, a_vel_coord_y, a_vcl_z_prom, a_vsl_z_prom, i_arr_temp, array_len, vel_len) {

var	contador_de_points_local = 0; // esto lo uso como divisor para estimar la vcl promedio de la track
var vcl_sumatoria_track = 0;
var vsl_sumatoria_track = 0;

	// establece el numero de orden donde empiezan a dibujarse los valores de VEL
	num_orden_inicio_track = ini_temp + floor(vel_len/2);

//	print("#_inicio_track", ini_temp); // log record
//	print("inicio_escritura_datos_track", num_orden_inicio_track); // log record
	
	
	// ajusta el punto final donde debe hacer el corte si le frecuencia es par o impar
	// si no se hace esta corrección salta un error cuando se modifica la frecuencia
	if (frame_fixed_track_zoide_chk == true) {
		fin_temp_corregido =  num_orden_inicio_track + array_len;
	}
	else {
		if (v_freq%2 == 0) { 
			fin_temp_corregido = fin_temp - floor(vel_len/2);
		}
		else {
			fin_temp_corregido = fin_temp - floor(vel_len/2) - 1;	
		}
	}

//		print ("fin_temp_corregido", fin_temp_corregido); 
	
	// inicia el bucle para evaluar la VEL en los TODOS los zoides
	for (i_vel = ini_temp + floor(vel_len/2); i_vel < fin_temp_corregido; i_vel++) {  // le saque el -1
//			print("punto donde empieza a tomar datos:", ini_temp + floor(vel_len/2), "punto donde termina de tomar datos:", fin_temp_corregido); // log record
//			print("vel_len", vel_len, "i_arr_temp", i_arr_temp, "array_len", array_len); // log record 
				
		zoide_x = getResult(titulo_result_coord_x, i_vel-1)*zuum; // asigna la coord x donde se va a dibujar la VEL
		zoide_y = getResult(titulo_result_coord_y, i_vel-1)*zuum; // asigna la coord y donde se va a dibujar la VEL
		a_vel_coord_x[i_arr_temp] = zoide_x; // asigna la coordena x del punto de vcl promedio al array, se puede fusionar con el anterior
		a_vel_coord_y[i_arr_temp] = zoide_y; // asigna la coordena y del punto de vcl promedio al array, se puede fusionar con el anterior
//			print("------------"); // log record
//			print("posicion en el array", i_arr_temp, "coord x", zoide_x); // log record
	
// 		aca poner el calculo de las velocidades 
// 		para cada punto voy a tomar una vel promedio del run, 
//		y tomando las coordenadas x,y del punto actual como el centro de ese run

		// esto determina donde empieza y termina EL espermatozoide que esta analizando ahora
		
		// establece el numero de registro donde comienza el run
		ini_run = i_vel - floor(vel_len/2); // print("ini_run", ini_run); // log record
		// establece el numero de registro donde termina el run
		fin_run = i_vel + floor(vel_len/2); // print("fin_run", fin_run); // log record

// INICIO CALCULO DE VCL
//			print("inicio calculo VCL"); // log record

		track_len_vcl_total = 0; // resetea el valor de VCL para volver a calcularlo
		track_len_vcl_parcial = 0; // resetea el valor de VCL para volver a calcularlo

			
		// inicia el bucle para calcular la distancia curvilineal del run
		for (i_vel_len = ini_run; i_vel_len < fin_run; i_vel_len++) {

			// asigna coordenadas x
			x_parcial_i = parseFloat((getResult(titulo_result_coord_x, i_vel_len-1)*zuum)); // print("x_parcial_i",x_parcial_i); // log record	
			x_parcial_f = parseFloat((getResult(titulo_result_coord_x, i_vel_len)*zuum)); // print("x_parcial_f",x_parcial_f); // log record
							
			// asigna coordenadas y	
			y_parcial_f = parseFloat((getResult(titulo_result_coord_y, i_vel_len)*zuum)); 
			y_parcial_i = parseFloat((getResult(titulo_result_coord_y, i_vel_len-1)*zuum));
							
			// calcula las diferencias entre final e inicial		
			delta_x_parcial = x_parcial_f - x_parcial_i; // print("delta_x_parcial:",delta_x_parcial); // log record
			delta_y_parcial = y_parcial_f - y_parcial_i; // print("delta_y_parcial:",delta_y_parcial); // log record

			// eleva al cuadrado
			delta_x_parcial_2 = pow(delta_x_parcial, 2); // print("delta_x_parcial_2", delta_x_parcial_2);
			delta_y_parcial_2 = pow(delta_y_parcial, 2); // print("delta_y_parcial_2", delta_y_parcial_2);
			sum_parcial = delta_x_parcial_2 + delta_y_parcial_2; //	print("sum_parcial_2", sum_parcial);

			// calcula la longitud parcial en tre dos puntos
			track_len_vcl_parcial = sqrt(sum_parcial); // print("longitud parcial entre puntos:", track_len_vcl_parcial); // lor record
			
			// calcula la longitud total de la track como sumatoria
			track_len_vcl_total = track_len_vcl_total + track_len_vcl_parcial;	// print("longitud acumulada de la track:", track_len_vcl_total); // log record

		} // fin del for
	
		// calculo del valor de VCL actual
		vcl_value = track_len_vcl_total/(v_run*zuum); // 2018-05-15 agregue corrección del zuum en el calculo de la velocidad
			// ajusta el valor de la velocidad si la escala esta activada
			if (usar_escala_chk == true) vcl_value = vcl_value * escala_microscopio;

		// asigna el valor de VCL al array para despues usarlo 
		a_vcl_z_prom[i_arr_temp] = vcl_value; // asigna el valor de VCL al array
		
		// va sumando los valores de VCL para luego estimar la vcl promedio de la track
		vcl_sumatoria_track = vcl_sumatoria_track + vcl_value;

		// escribe en resultados el valor de VCL calculado para chequeo, se puede sacar cuando este verificado
		posicion_tabla_result = num_orden_inicio_track + i_arr_temp - 1;
//			print("#_posicion", posicion_tabla_result + 1);
		setResult("x [vel]", posicion_tabla_result, a_vel_coord_x[i_arr_temp] ); //log result record
		setResult("y [vel]", posicion_tabla_result, a_vel_coord_y[i_arr_temp] ); //log result record
	
		titulo_temp = "VCL-"+v_run+"s";
		setResult(titulo_temp, posicion_tabla_result, a_vcl_z_prom[i_arr_temp] ); //log result record
		
//			print("posicion del array donde almacena la VCL", i_arr_temp, "valor VCL almacenado:", a_vcl_z_prom[i_arr_temp], "coordenada x del valor VCL", a_vel_coord_x[i_arr_temp]); // log record
//			print("fin calculo VCL"); // log record
// FIN CALCULO VCL

// INICIO CALCULO VSL	
//			print("Inicio calculo VSL"); // log record
		
		// inicia el calculo de distancia lineal, no necesita bucle porque son solo dos puntos
		vsl_x_temp_ini = getResult(titulo_result_coord_x, ini_run-1)*zuum;	// print("vsl_x_temp_ini:", vsl_x_temp_ini-1); // log record
		vsl_x_temp_fin = getResult(titulo_result_coord_x, fin_run-1)*zuum; // print("vsl_x_temp_fin:", vsl_x_temp_fin-1); // log record
		vsl_y_temp_ini = getResult(titulo_result_coord_y, ini_run-1)*zuum; // print("vsl_y_temp_ini:", vsl_y_temp_ini-1); // log record
		vsl_y_temp_fin = getResult(titulo_result_coord_y, fin_run-1)*zuum; // print("vsl_y_temp_fin:", vsl_y_temp_fin-1); // log record		
		
		delta_x_vsl = vsl_x_temp_fin - vsl_x_temp_ini; // print("delta_x_vsl:", delta_x_vsl); // log record
		delta_y_vsl = vsl_y_temp_fin - vsl_y_temp_ini; // print("delta_y_vsl:", delta_y_vsl); // log record
									
		track_len_vsl = sqrt((pow(delta_x_vsl, 2) + pow(delta_y_vsl, 2))); // print("track_len_vsl", track_len_vsl); // log record
			
		// calculo del valor de VSL actual
		vsl_value = track_len_vsl/(v_run*zuum); // 2018-05-15 agregue corrección del zuum en el calculo de la velocidad;
			// ajusta el valor de la velocidad si la escala esta activada
			if (usar_escala_chk == true) vsl_value = vsl_value * escala_microscopio;
			
		// asigna el valor de VSL al array para despues usarlo 
		a_vsl_z_prom[i_arr_temp]= vsl_value; // asigna el valor de VsL al array

		// va sumando los valores de VSL para luego estimar la vcl promedio de la track
		vsl_sumatoria_track = vsl_sumatoria_track + vsl_value;
		
		// escribe en resultados el valor de VSL calculado para chequeo, se puede sacar cuando este verificado
		titulo_temp = "VSL-"+v_run+"s";
		setResult(titulo_temp, posicion_tabla_result, a_vsl_z_prom[i_arr_temp] ); //log result record
// FIN CALCULO VSL

	

		// incrementos necesarios al finalizar el loop
		contador_de_points_local++; // imcrementa el divisor de las velocidades promedio
		i_arr_temp++;	// incrementa la posicion del array
	} // fin for VEL TODOS los zoides

	// estimación de los valores promedios de la track
	vcl_promedio_track = vcl_sumatoria_track / contador_de_points_local;
	vsl_promedio_track = vsl_sumatoria_track / contador_de_points_local;

//	print("contador_de_points_local", contador_de_points_local);

		// Esto se modifico para que calule todos los valroes ajustados por escala y no solo los promedios
		//	if (usar_escala_chk == true) {
		//	vcl_promedio_track = vcl_promedio_track * escala_microscopio;
		//	vsl_promedio_track = vsl_promedio_track * escala_microscopio;
		//	}
	
	return a_vel_coord_x;
	return a_vel_coord_y;
	return a_vcl_z_prom;
	return a_vsl_z_prom;
	return array_len;
	return num_orden_inicio_track;

} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// funcion para  calcular los valores y hacer los array de velocidades
function ARRAY_VAP(a_vel_coord_x_VAP, a_vel_coord_y_VAP, a_vap_z_prom, i_arr_temp, array_len, vel_len) {

var	contador_de_points_local = 0; // esto lo uso como divisor para estimar la vcl promedio de la track
var vap_sumatoria_track = 0;

	// convierte variables globales en locales
	ini_temp_l = ini_temp;
	fin_temp_l = fin_temp;
	
	// establece el numero de orden donde empiezan a dibujarse los valores de VAP tiene en cuena el rango_vap
	num_orden_inicio_track = ini_temp_l + floor(vel_len/2) + rango_vap/2 ;
	num_orden_temp = num_orden_inicio_track; // pasa el numero de inicio a una variable que cambie a medida que se necesite
	
	if (frame_fixed_track_zoide_chk == true) {
		fin_temp_corregido =  num_orden_inicio_track + array_len - rango_vap/2; 
	}
	else {
		if (v_freq%2 == 0) { 
			fin_temp_corregido = fin_temp_l - floor(vel_len/2) - (rango_vap/2);
		}
		else {
			fin_temp_corregido = fin_temp_l - floor(vel_len/2) - (rango_vap/2) - 1;	
		}
	}
	
	// establece el numero de orden donde termina de dibujarse los valores de VEL
	num_orden_fin_track = fin_temp_corregido;

//		print("num_orden_inicio_track",num_orden_inicio_track,"num_orden_fin_track",num_orden_fin_track); // log record

	// inicia el bucle para evaluar la VEL en los TODOS los zoides
	for (i_vel = num_orden_inicio_track; i_vel < num_orden_fin_track; i_vel++) {  // le saque el -1
//			print("punto donde empieza a tomar datos:", ini_temp + floor(vel_len/2), "punto donde termina de tomar datos:", fin_temp_corregido); // log record
//			print("vel_len", vel_len, "i_arr_temp", i_arr_temp, "array_len", array_len); // log record 
				
		zoide_x = getResult("x [vap]", i_vel-1); // asigna la coord x donde se va a dibujar la VEL
		zoide_y = getResult("y [vap]", i_vel-1); // asigna la coord y donde se va a dibujar la VEL
		a_vel_coord_x_VAP[i_arr_temp] = zoide_x; // asigna la coordena x del punto de vcl promedio al array, se puede fusionar con el anterior
		a_vel_coord_y_VAP[i_arr_temp] = zoide_y; // asigna la coordena y del punto de vcl promedio al array, se puede fusionar con el anterior
//			print("------------"); // log record
//			print("track #", n_zoide, "posicion en el array VAP", i_arr_temp, "coord x", zoide_x); // log record
	
// 		aca poner el calculo de las velocidades 
// 		para cada punto voy a tomar una vel promedio del run, 
//		y tomando las coordenadas x,y del punto actual como el centro de ese run

		// esto determina donde empieza y termina EL espermatozoide que esta analizando ahora	
		// establece el numero de registro donde comienza el run
		ini_run = i_vel - floor(vel_len/2); // print("ini_run", ini_run); // log record
		// establece el numero de registro donde termina el run
		fin_run = i_vel + floor(vel_len/2); // print("fin_run", fin_run); // log record

// INICIO CALCULO DE VAP con coordenadas promediadas
// La VAP es la VCL de las coordendas promediadas, por eso use los mismos algoritmos para la VCL 
//			print("inicio calculo VAP"); // log record

		if (a_vap_z_prom_empty == false){ // si el array a_vap_z_prom no esta vacío calcula la VAP
			
			track_len_vcl_total = 0; // resetea el valor de VCL para volver a calcularlo
			track_len_vcl_parcial = 0; // resetea el valor de VCL para volver a calcularlo
			
			// inicia el bucle para calcular la distancia curvilineal del run
			for (i_vel_len = ini_run; i_vel_len < fin_run; i_vel_len++) {
	
				// asigna coordenadas x
				x_parcial_i = parseFloat((getResult("x [vap]", i_vel_len-1))); // print("x_parcial_i",x_parcial_i); // log record	
				x_parcial_f = parseFloat((getResult("x [vap]", i_vel_len))); //	print("x_parcial_f",x_parcial_f); // log record
								
				// asigna coordenadas y	
				y_parcial_f = parseFloat((getResult("y [vap]", i_vel_len))); 
				y_parcial_i = parseFloat((getResult("y [vap]", i_vel_len-1)));
								
				// calcula las diferencias entre final e inicial		
				delta_x_parcial = x_parcial_f - x_parcial_i; // print("delta_x_parcial:",delta_x_parcial); // log record
				delta_y_parcial = y_parcial_f - y_parcial_i; // print("delta_y_parcial:",delta_y_parcial); // log record
	
				// eleva al cuadrado
				delta_x_parcial_2 = pow(delta_x_parcial, 2); // print("delta_x_parcial_2", delta_x_parcial_2);
				delta_y_parcial_2 = pow(delta_y_parcial, 2); // print("delta_y_parcial_2", delta_y_parcial_2);
				sum_parcial = delta_x_parcial_2 + delta_y_parcial_2; //	print("sum_parcial_2", sum_parcial);
	
				// calcula la longitud parcial en tre dos puntos
				track_len_vcl_parcial = sqrt(sum_parcial); // print("longitud parcial entre puntos:", track_len_vcl_parcial); // lor record
				
				// calcula la longitud total de la track como sumatoria
				track_len_vcl_total = track_len_vcl_total + track_len_vcl_parcial;	// print("longitud acumulada de la track:", track_len_vcl_total); // log record
	
			} // fin del for
		
			// calculo del valor de VAP actual
			vap_value = track_len_vcl_total/(v_run*zuum); // 2018-05-15 agregue corrección del zuum en el calculo de la velocidad
				// ajusta el valor de la velocidad si la escala esta activada
				if (usar_escala_chk == true) vap_value = vap_value * escala_microscopio;
	
			// asigna el valor de VAP al array para despues usarlo 
			a_vap_z_prom[i_arr_temp] = vap_value; // asigna el valor de VAP al array

			vap_sumatoria_track = vap_sumatoria_track + vap_value;
			
		} // fin del if
		else {
			a_vap_z_prom[i_arr_temp] = ""; // asigna un valor vacío si el array esta vacio	
		}
			// escribe en resultados el valor de VAP calculado para chequeo, se puede sacar cuando este verificado
			titulo_temp = "VAP("+rango_vap+")-"+v_run+"s";
			setResult(titulo_temp, num_orden_temp-1, a_vap_z_prom[i_arr_temp]); //log result record
			
// FIN CALCULO VAP

		// incrementos necesarios al finalizar el loop
		num_orden_temp++;	// incremento de la posicion en el numero de orden
		contador_de_points_local++;
		i_arr_temp++;	// incrementa la posicion del array
	} // fin for VEL TODOS los zoides

	// estimación de los VAP promedio de la track
	vap_promedio_track = vap_sumatoria_track / contador_de_points_local;


	return a_vel_coord_x_VAP;
	return a_vel_coord_y_VAP;
	return a_vap_z_prom;
	return array_len;
	
} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// Escribre los valores de las coordendas promedio en la tabla de resultados para poder calcular la VAP luego
function WRITE_VAP_COORD_IN_RESULTS(ini_temp, fin_temp) {
	 	
	// estas las voy a usar para escribir en los resultados las coordenas x,y de para estimar la VAP
	posicion_inicio_track = ini_temp; 
	posicion_final_track = fin_temp;

	rango_coord_vap_temp = fin_temp - ini_temp;
	
	n_temp = 0; // inicia esta variable del loop 
	x_vap_sum = 0; // limpia estos valores por las dudas
	y_vap_sum = 0; // limpia estos valores por las dudas
	
	// este bucle recorre toda la longitud de la track desde el inicio mas el rango_vap/2 hasta el fin meno el rango_vap/2
	for (i_orden_vap = 0; i_orden_vap < rango_coord_vap_temp - rango_vap + 1; i_orden_vap++) {

		// calcula los promedios de las coordenadas x e y dentro del rango_vap
		while (n_temp < rango_vap + 1) {
			// la posicion donde busca las coordendas para estimar el promedio. esta definida por: la posicion inicial de la track mas el punto de avance mas el punto del rango promediable
			numero_orden = posicion_inicio_track + i_orden_vap + n_temp - 1;
			
//		print("numero_orden", numero_orden);
			x_vap_temp = parseFloat(getResult(titulo_result_coord_x, numero_orden)*zuum); // busca el valor del x para promediar detro de rango vap
			y_vap_temp = parseFloat(getResult(titulo_result_coord_y, numero_orden)*zuum); // busca el valor del x para promediar detro de rango vap

			// sumatoria de variables
			x_vap_sum = x_vap_sum + x_vap_temp;
			y_vap_sum = y_vap_sum + y_vap_temp;

			//incrementa el punto del rango_vap
			n_temp++;							
		} // fin del while

		// calcula el valor de la coordenada promedio
		coord_x_vap = (x_vap_sum / (rango_vap + 1));
		coord_y_vap = (y_vap_sum / (rango_vap + 1));

		// escribe los valores en los resultados
		setResult("x [vap]", posicion_inicio_track + i_orden_vap + floor(rango_vap/2) -1, coord_x_vap);
		setResult("y [vap]", posicion_inicio_track + i_orden_vap + floor(rango_vap/2) -1, coord_y_vap);
		
		// limpio las variables por las dudas
		x_vap_sum = 0; // limpia estos valores por las dudas
		y_vap_sum = 0; // limpia estos valores por las dudas
		n_temp = 0; // reinicia esta variable del loop 
		
	} // fin del for

	
} // fin function
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv


//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
// funcion para dibujar las variables como puntos de color
function DIBUJAR_DOTS_COLOR(a_var_coord_x, a_var_coord_y, a_var_z_prom, array_len) {

	// limpia las variables??
	var_max = "";
	mar_min = "";

 	if (relative_value_chk == true) {
 		// obtiene las estadisticas del array 
		Array.getStatistics(a_var_z_prom, var_min, var_max, var_mean, stdDev);	
 	}
 	else {
 		var_max = var_max_abs;
 		var_min = var_min_abs; 		
 	}
	
	var_range = var_max - var_min; // calculo del rango de velocidades para representar la velocidad relativa
		
	// Dibujo del punto y asignacion de colores
	for (i=1; i<a_var_z_prom.length; i++) {
		var_value = a_var_z_prom[i];
		var_coord_x = a_var_coord_x[i] + desfasaje_x; // le agregue el termino de desfasaje para poder correr las tracks a una zona limpia
		var_coord_y = a_var_coord_y[i] + desfasaje_y; // le agregue el termino de desfasaje para poder correr las tracks a una zona limpia			

//			print("a_var_coord_x["+i+"]", a_var_coord_x[i],"+ desfasaje_x", desfasaje_x, "= var_coord_x", var_coord_x); // log record
		
	// asignacion los colores del punto segun el valor de la variable  	
		// si se excede del valor del rango max-min pinta el punto de color blanco
		if (((var_value-var_min)/(var_range))>1 || ((var_value-var_min)/(var_range))<0) {
			red=255;
			green=255;
			blue=255;
		} // fin del if

		// si el valor esta dentro del rango max-min pinta el punto de colores rojo a verde
		else {

			// asigna colores segun el tipo de grafico
			if (type_graph == "Fractal Dimension" && option_graf_DF == "Continuous") {
				red = 255*(var_value-var_min)/(var_range);
				green = 255*(1-(var_value-var_min)/(var_range));		
			} // fin if
			
			// Se invierte el color a pedido de Steve, rojo para el maximo y verde para el minimo
			else if (type_graph == "Intensity") { 
				green = 255*(var_value-var_min)/(var_range);
				red = 255*(1-(var_value-var_min)/(var_range));
			} // fin else
			
			else if (type_graph == "Fractal Dimension" && option_graf_DF == "Categorical") {
				if (var_value < 1.3 && 	DF_lineal_chk == true) green = 255; // le pone color verde si es lineal
				if (var_value >= 1.3 && var_value < 1.8 && DF_transicional_chk == true) blue = 255; // le pone color azul si es transicional
				if (var_value > 1.8 && 	DF_hiperactivado_chk == true) red = 255; // le pone color rojo si es Hiperactivado
			} // fin else if
			
			else {
				green = 255*(var_value-var_min)/(var_range);
				red = 255*(1-(var_value-var_min)/(var_range));
			} // fin else
									
		} // fin del else
		
//			print("vcl_value", vcl_value, "red", red, "green", green, "blue", blue); // log record
		dot_size=4;
		setColor(red, green, blue);
				
		// dibuja el punto con el color asignado
		fillOval(var_coord_x - dot_size/2, var_coord_y - dot_size/2, dot_size, dot_size);

		// reasignacion de variables que se debn resetear antes de analizar un nuevo zoide por las dudas
		red = 0;
		green = 0;
		blue = 0; 
	} // fin for

//		Array.print(a_vcl_z_prom); // log record
	if (type_graph == "Fractal Dimension" && option_graf_DF == "Categorical") {
		WRITE_REF_DIMENSION_FRACTAL();
	}
	else {
		if (draw_color_bar == true) DIBUJAR_BARRA_INTENSIDAD(var_max, var_min); // dibuja la barra de intensidad
	}

} // fin function DIBUJAR_DOTS_COLOR
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr


//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr
// funcion para dibujar la barra de intensidad
function DIBUJAR_BARRA_INTENSIDAD(var_max, var_min) {

	// esto define la posicion del rectangulo, que no lo voy a dibujar pero me sirve de referencia
	pos_rect_x = 100;
	pos_rect_y = 100;
	rect_width = getWidth()*0.03;
	rect_height = getHeight()*0.25;
		
	green = 0;
	red = 0;
	blue = 0;
	
	// bucle para pintar la barra 
	for (pos_y = 1; pos_y < rect_height; pos_y++) { // for y; cambia de fila
		//asignacion de posicion de llenado
		pos_fill_y = pos_rect_y + pos_y;
		
		// asignacion de colores deoendiendo el tipo de grafico
		if (type_graph == "Fractal Dimension" && option_graf_DF == "Continuous") {
			red = 255 * (1 - (pos_y / rect_height));
			green = 255 * (pos_y / rect_height);
		}

				// Esto invierte el color de la intensidad el maximo es rojo y el minimo es verde a pedido de steve
		else if (type_graph == "Intensity") {
			green = 255 * (1 - (pos_y / rect_height));
			red = 255 * (pos_y / rect_height);			
		}
		
		else {
			green = 255 * (1 - (pos_y / rect_height));
			red = 255 * (pos_y / rect_height);
		}
			
			for (pos_x = 1; pos_x < rect_width; pos_x++) { // for x; recorre la fila
				pos_fill_x = pos_rect_x + pos_x;
				setColor(red, green, blue);
				fillOval(pos_fill_x, pos_fill_y, 1, 1);
			} // fin for x
				
		} // fin for y
	
	// Escribe los valores de velocidad en los extremos de la barra
	text_var_max = d2s(var_max, 1);
	text_var_min = d2s(var_min, 1);
	size_f = 32; // tamaño fuente

	setColor(255,255,255);
	setFont("Arial", size_f, "antiliased");
	drawString(text_var_max, pos_rect_x + (rect_width*1.2), pos_rect_y + (size_f/2));
	drawString(text_var_min, pos_rect_x + (rect_width*1.2), pos_rect_y + rect_height + (size_f/2));
	
} // fin function
//rrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr


// aca dejo las funciones que voy eliminando


/*

function DIALOGO_ASIGNAR_TITULO_COLUMNA() {

	//Crea un cuadro de dialogo para elegir algunos parametros
	Dialog.create("Select data columns");
	
	// cuadro de dialogo valores de titulos de columnas de resultados	

		Dialog.addMessage("# # #  Columns headings  # # #"); 
	Dialog.addChoice("Trajectory column:", columns_label_array, saved_label_trayectoria);
	Dialog.addChoice("X coordinates column:", columns_label_array, saved_titulo_result_coord_x);
	Dialog.addChoice("Y coordinates column:", columns_label_array, saved_titulo_result_coord_y);

	Dialog.show();
	
	// asignar valores de titulos de columnas de resultados	
	titulo_result_coord_x = Dialog.getString();
	titulo_result_coord_y = Dialog.getString();
	label_trayectoria = Dialog.getString();

	saved_titulo_result_coord_x = titulo_result_coord_x;
	saved_titulo_result_coord_y = titulo_result_coord_y;
	saved_label_trayectoria = label_trayectoria;
	
}// fin function DIALOGO_ASIGNAR_TITULO_COLUMNA
//optionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoptionoption

*/



